      program extract_phi_eq
      implicit none
      include '../includes/max.inc'
      include '../includes/param.inc'

      integer band,Nb,i,m,Nq,band_min,ios
      double precision phi_eq(1:Nmax)
      double precision e(0:Nmax)
      double precision dens(0:Nmax),capa(0:Nmax)
      double precision lambda_lo(1:Nbmx),no_lo(1:Nbmx)
      double precision lambda_hi(1:Nbmx),no_hi(1:Nbmx)
      double precision T(0:Nmax+1)
      double precision temp(0:Nmax),Tsol,Tesp
      double precision alt(0:Nmax),pres(0:Nmax)
      double precision grav(0:Nmax)

      call read_atmos_data(m,Nb,Nq,e,lambda_lo,lambda_hi,dens,capa,
     &     grav,T,alt,temp,pres,Tsol,Tesp)
      do band=1,Nb
         no_lo(band)=1.0D+4/lambda_hi(band)
         no_hi(band)=1.0D+4/lambda_lo(band)
      enddo

      open(10,file='band_min')
      read(10,*) band_min
      close(10)

c     Ouverture du fichier
      open(12,file='./phi_eq.txt',status='old',iostat=ios)
      if (ios.ne.0) then
         close(12)
         write(*,*) 'File "phi_eq.txt" could not be opened"'
      else
         do band=1,band_min-1
            read(12,*)
         enddo
         read(12,'(1p(100e11.3))') (phi_eq(i),i=1,m)
         close(12)
         
         open(11,file='phib.txt')
         do i=1,m
            write(11,*) (e(i)+e(i-1))/2.0D+3,phi_eq(i)
         enddo
         close(11)

      endif


      end
