      program grads_test

      implicit none

      include '../includes/param.inc'
      include '../includes/max.inc'
      include '../includes/formats.inc'

      integer i,band,irec,m,Nb
      double precision x(1:Nbmx,1:Nmax)
      character*100 file_in
      integer strlen
      real tmp

      Nb=68
      m=81
      do i=1,m
         do band=1,Nb
            x(i,band)=dble(band)*1.5D+1
         enddo ! band
      enddo ! i

c     Cration du fichier de donnes 'x.dat'
c     Cration du fichier de contrle 'x.ctl'

      file_in='/Users/vincent/grads_tmp/x.dat'
      open(77,file=file_in(1:strlen(file_in))
     &     ,form='unformatted'
     &     ,access='direct'
     &     ,recl=4)
      irec=0
      do i=1,m
         do band=1,Nb
            irec=irec+1
            tmp=real(x(i,band))
            write(77,REC=irec) tmp
         enddo
      enddo
      close(77)

      file_in='/Users/vincent/grads_tmp/x.ctl'
      open(10,file=file_in(1:strlen(file_in)))
      write(10,'(a)')'DSET  ^x.dat'
      write(10,'(a)')'UNDEF                1.E+30'
      write(10,'(a)')'FORMAT'
      write(10,'(a)')'TITLE              Echanges'
      write(10,'(a,i5,a)')'XDEF    ',Nb,'         LINEAR 1 1'
      write(10,'(a)')'YDEF    1            LINEAR 0 1'
      write(10,'(a,i5,a)')'ZDEF    ',m,'          LINEAR 1 1'
      write(10,'(a)')'TDEF    1            LINEAR 02JAN1987 1HR'
      write(10,'(a)')'VARS    1'
      write(10,'(a,i5,a)')
     &     'x'//'           ',m,' 99 echanges entre couches'
      write(10,'(a)')'ENDVARS'
      close(10)

      end
