#!/bin/bash

narg=$#

if [ $narg -eq 1 ] ; then
echo 'This script will plot the required data or result'
echo 'type "plot help data" or "plot help results" for more iformation'
elif [ $narg -eq 2 -a $2 = 'data' ] ; then

echo 'Two arguments must be specified as follows;'
echo 'The first argument must be one of these:'
echo '  + ka : for absorption coefficients'
echo '  + ks : for scattering coefficients'
echo '  + albedo : for single-scattering albedoes'
echo '  + g : for phase function asymetry parameters'
echo ''
echo 'The second argument must be one of the following:'
echo '  + gas : for data relative to a gas'
echo '  + aerosol : for data relative to an aerosol'
echo '  + cloud : for data relative to a cloud'
echo '  + total : for a total albedo or asymetry parameter'
echo '  + co2 : for a co2 continuum absorption coefficient'
echo '  + h2o : for a h2o continuum absorption coefficient'

elif [ $narg -eq 2 -a $2 = 'results' ] ; then

echo 'One or several arguments may be specified'
echo 'For two-dimensional plots:'
echo '"ner"'
echo '"cooling-rates"'
echo '"budget total / gas-ground / gas-space / gas-gas"'
echo '"budget * analytic"'
echo '"st-dev * *"'
echo ''
echo 'For one-dimension plots'
echo '"flux net toa"'
echo '"budget"'
echo '"cooling-rate"'

fi