#!/bin/bash

go=0

while read line
do
  bw=$line
done < "bw"

while read line
do
  path=$line
done < "tmp_dir"

ctl='open '$path
draw='d '
title='draw title '

if [ $2 = 'total' ] ; then
tmp1='bilan_tot_theo'
if [ $bw -eq 1 ] ; then
cp rgb_bilfa_bw rgb
cp cl_bfa_bw cl
else
cp rgb_bilfa rgb
cp cl_bfa cl
fi
title=$title'Analytic total budget (mW/m\`a3\`n/cm\`a-1\`n)'
go=1
elif [ $2 = 'gas-ground' ] ; then
tmp1='bilan_gs_theo'
if [ $bw -eq 1 ] ; then
cp rgb_bilfags_bw rgb
cp cl_bfags_bw cl
else
cp rgb_bilfags rgb
cp cl_bfags cl
fi
title=$title'Analytic gas-ground budget (mW/m\`a3\`n/cm\`a-1\`n)'
go=1
elif [ $2 = 'gas-space' ] ; then
tmp1='bilan_ge_theo'
if [ $bw -eq 1 ] ; then
cp rgb_bilfage_bw rgb
cp cl_bfage_bw cl
else
cp rgb_bilfage rgb
cp cl_bfage cl
fi
title=$title'Analytic gas-space budget (mW/m\`a3\`n/cm\`a-1\`n)'
go=1
elif [ $2 = 'gas-gas' ] ; then
tmp1='bilan_gg_theo'
if [ $bw -eq 1 ] ; then
cp rgb_bilfagg_bw rgb
cp cl_bfagg_bw cl
else
cp rgb_bilfagg rgb
cp cl_bfagg cl
fi
title=$title'Analytic gas-gas budget (mW/m\`a3\`n/cm\`a-1\`n)'
go=1
fi


ctl=$ctl$tmp1'.ctl'
draw=$draw$tmp1

file=$tmp1
t1='gxeps -c -i out.gx -o '$file'.ps'
t2='gzip -f '$file'.ps'
t3='gv --orientation=LANDSCAPE '$file'.ps.gz'
cp levNb lev
cp linesNb lines

echo $ctl > ctl
echo $draw > d
echo $title > title
echo $t1 > t1
echo $t2 > t2
echo $t3 > t3
cat d title > dr
cat t0 t1 t2 t3 > t
cp c2 c
echo $go > out
