      program vizu

      implicit none

      include '../includes/param.inc'
      include '../includes/max.inc'
      include '../includes/formats.inc'
 41   format(I3,100e17.8)
 20   format(/a,10f10.5)

c     
c     Ce programme crit les donnes dans les fichiers de grads
c     

      integer i,j,irec,n_cont,band,quad,k,m,mr,lv,lh,Nl_mx
      integer recombine,n,recombine_default,i_test
      parameter(n_cont=12)
      parameter(Nl_mx=200)
      integer Ntmx,ntplot,itplot
      parameter(Ntmx=100)
      double precision dT
      double precision clev(1:n_cont),raf
      real*4 tmp
      double precision e(0:Nmax),rhoCp(1:Nmax)
      double precision dens(0:Nmax),capa(0:Nmax)
      double precision lambda_c(1:Nbmx),no_c(1:Nbmx)
      double precision lambda_lo(1:Nbmx),no_lo(1:Nbmx)
      double precision lambda_hi(1:Nbmx),no_hi(1:Nbmx)
      double precision nbw(1:Nbmx)
      double precision lbw(1:Nbmx)
      double precision tau_d(1:Nbmx,1:Nmax)
      double precision omega_gaz(1:Nbmx,1:Nmax)
      double precision omega_aero(1:Nbmx,1:Nmax)
      double precision omega_cloud(1:Nbmx,1:Nmax)
      double precision omega_tot(1:Nbmx,1:Nmax)
      double precision g_gaz(1:Nbmx,1:Nmax)
      double precision g_aero(1:Nbmx,1:Nmax)
      double precision g_cloud(1:Nbmx,1:Nmax)
      double precision g_tot(1:Nbmx,1:Nmax)
      double precision ka_gaz(1:Nbmx,1:Nmax)
      double precision phi_eq(1:Nbmx,1:Nmax)
      double precision ka_aero(1:Nbmx,1:Nmax)
      double precision ka_cloud(1:Nbmx,1:Nmax)
      double precision tau_cloud(1:Nbmx,1:Nmax)
      double precision ka_cont_co2(1:Nbmx,1:Nmax)
      double precision ka_cont_h2o(1:Nbmx,1:Nmax)
      double precision kd_gaz(1:Nbmx,1:Nmax)
      double precision kd_aero(1:Nbmx,1:Nmax)
      double precision kd_cloud(1:Nbmx,1:Nmax)
      double precision tau_aero(1:Nbmx,1:Nmax)
      double precision tau_abs_aero(1:Nbmx,1:Nmax)
      double precision tau_diff_aero(1:Nbmx,1:Nmax)
      double precision tau_abs_cloud(1:Nbmx,1:Nmax)
      double precision tau_diff_cloud(1:Nbmx,1:Nmax)
      double precision tau1_tot(1:Nbmx,1:Nmax)
      double precision tau2_tot(1:Nbmx,1:Nmax)
      double precision tau3_tot(1:Nbmx,1:Nmax)

      double precision tPNEsym(0:Nmax+1,0:Nmax+1)
      double precision tPNEsym2(0:Nmax+1,0:Nmax+1)
      double precision dtPNEsym(0:Nmax+1,0:Nmax+1)
      double precision sdtPNE(0:Nmax+1,0:Nmax+1)
      double precision tPNEtheo(0:Nmax+1,0:Nmax+1)
      double precision tPNEtheo2(0:Nmax+1,0:Nmax+1)
      double precision dtPNEtheo(0:Nmax+1,0:Nmax+1)
      double precision inc_tPNEsym(0:Nmax+1,0:Nmax+1)
      double precision inc_tPNEsym2(0:Nmax+1,0:Nmax+1)
      double precision inc_dtPNEsym(0:Nmax+1,0:Nmax+1)
      double precision CR(0:Nmax+1,0:Nmax+1)
      double precision CR_theo(0:Nmax+1,0:Nmax+1)
      double precision inc_CR(0:Nmax+1,0:Nmax+1)
      double precision fnetb_pne(1:Nbmx,0:Nmax+1)
      double precision fnetb_pne_theo(1:Nbmx,0:Nmax+1)
      double precision inc_fnetb_pne(1:Nbmx,0:Nmax+1)

      double precision bil_freq_tot(1:Nbmx,1:Nmax)
      double precision bil_freq_tot2(1:Nbmx,1:Nmax)
      double precision bilkj_freq_tot(1:Nbmx,1:Nmax)
      double precision dbil_freq_tot(1:Nbmx,1:Nmax)
      double precision dbilkj_freq_tot(1:Nbmx,1:Nmax)
      double precision dsbil_freq_tot(1:Nbmx,1:Nmax)
      double precision bil_freq_gs(1:Nbmx,1:Nmax)
      double precision bilkj_freq_gs(1:Nbmx,1:Nmax)
      double precision bil_freq_gs2(1:Nbmx,1:Nmax)
      double precision dbil_freq_gs(1:Nbmx,1:Nmax)
      double precision dbilkj_freq_gs(1:Nbmx,1:Nmax)
      double precision dsbil_freq_gs(1:Nbmx,1:Nmax)
      double precision bil_freq_ge(1:Nbmx,1:Nmax)
      double precision bilkj_freq_ge(1:Nbmx,1:Nmax)
      double precision bil_freq_ge2(1:Nbmx,1:Nmax)
      double precision dbil_freq_ge(1:Nbmx,1:Nmax)
      double precision dbilkj_freq_ge(1:Nbmx,1:Nmax)
      double precision dsbil_freq_ge(1:Nbmx,1:Nmax)
      double precision bil_freq_gg(1:Nbmx,1:Nmax)
      double precision bilkj_freq_gg(1:Nbmx,1:Nmax)
      double precision bil_freq_gg2(1:Nbmx,1:Nmax)
      double precision dbil_freq_gg(1:Nbmx,1:Nmax)
      double precision dbilkj_freq_gg(1:Nbmx,1:Nmax)
      double precision dsbil_freq_gg(1:Nbmx,1:Nmax)
      double precision inc_bil_freq_tot(1:Nbmx,1:Nmax)
      double precision inc_bil_freq_gs(1:Nbmx,1:Nmax)
      double precision inc_bil_freq_ge(1:Nbmx,1:Nmax)
      double precision inc_bil_freq_gg(1:Nbmx,1:Nmax)
      double precision inc_bilkj_freq_tot(1:Nbmx,1:Nmax)
      double precision inc_bilkj_freq_gs(1:Nbmx,1:Nmax)
      double precision inc_bilkj_freq_ge(1:Nbmx,1:Nmax)
      double precision inc_bilkj_freq_gg(1:Nbmx,1:Nmax)
      double precision bil_freq_tot_theo(1:Nbmx,1:Nmax)
      double precision bilkj_freq_tot_theo(1:Nbmx,1:Nmax)
      double precision bil_freq_tot_theo2(1:Nbmx,1:Nmax)
      double precision dbil_freq_tot_theo(1:Nbmx,1:Nmax)
      double precision bil_freq_gs_theo(1:Nbmx,1:Nmax)
      double precision bilkj_freq_gs_theo(1:Nbmx,1:Nmax)
      double precision bil_freq_gs_theo2(1:Nbmx,1:Nmax)
      double precision dbil_freq_gs_theo(1:Nbmx,1:Nmax)
      double precision bil_freq_ge_theo(1:Nbmx,1:Nmax)
      double precision bilkj_freq_ge_theo(1:Nbmx,1:Nmax)
      double precision bil_freq_ge_theo2(1:Nbmx,1:Nmax)
      double precision dbil_freq_ge_theo(1:Nbmx,1:Nmax)
      double precision bil_freq_gg_theo(1:Nbmx,1:Nmax)
      double precision bilkj_freq_gg_theo(1:Nbmx,1:Nmax)
      double precision bil_freq_gg_theo2(1:Nbmx,1:Nmax)
      double precision dbil_freq_gg_theo(1:Nbmx,1:Nmax)
      double precision dsbilkj_freq_tot(1:Nbmx,1:Nmax)
      double precision dsbilkj_freq_gs(1:Nbmx,1:Nmax)
      double precision dsbilkj_freq_ge(1:Nbmx,1:Nmax)
      double precision dsbilkj_freq_gg(1:Nbmx,1:Nmax)
      double precision dbilkj_freq_tot_theo(1:Nbmx,1:Nmax)
      double precision dbilkj_freq_gs_theo(1:Nbmx,1:Nmax)
      double precision dbilkj_freq_ge_theo(1:Nbmx,1:Nmax)
      double precision dbilkj_freq_gg_theo(1:Nbmx,1:Nmax)
      double precision dbil_tot_theo(1:Nbmx)
      double precision dbil_ge_theo(1:Nbmx)
      double precision dbil_gs_theo(1:Nbmx)
      double precision dbil_gg_theo(1:Nbmx)

      double precision pne_si1(0:Nmax+1,1:Nbmx)
      double precision pne_ei1(0:Nmax+1,1:Nbmx)
      double precision pne_si2(0:Nmax+1,1:Nbmx)
      double precision pne_ei2(0:Nmax+1,1:Nbmx)
      double precision bil_sol1(1:Nbmx)
      double precision bil_sol_sg1(1:Nbmx)
      double precision bil_sol_se1(1:Nbmx)
      double precision bil_sol2(1:Nbmx)
      double precision bil_sol_sg2(1:Nbmx)
      double precision bil_sol_se2(1:Nbmx)
      double precision bil_esp1(1:Nbmx)
      double precision bil_esp_eg1(1:Nbmx)
      double precision bil_esp_es1(1:Nbmx)
      double precision bil_esp2(1:Nbmx)
      double precision bil_esp_eg2(1:Nbmx)
      double precision bil_esp_es2(1:Nbmx)
      double precision dbil_sol(1:Nbmx)
      double precision dbil_sol_sg(1:Nbmx)
      double precision dbil_sol_se(1:Nbmx)
      double precision dbil_esp(1:Nbmx)
      double precision dbil_esp_eg(1:Nbmx)
      double precision dbil_esp_es(1:Nbmx)
      double precision dbil_sol_int,dbil_esp_int
      double precision dbil_sg_int,dbil_se_int,dbil_ge_int

      double precision psi_theo(1:Nmax)
      double precision psi_gs_theo(1:Nmax)
      double precision psi_ge_theo(1:Nmax)
      double precision psi_gg_theo(1:Nmax)
      double precision psi_theo2(1:Nmax)
      double precision psi_gs_theo2(1:Nmax)
      double precision psi_ge_theo2(1:Nmax)
      double precision psi_gg_theo2(1:Nmax)
      double precision psiKj_theo(1:Nmax)
      double precision psiKj_gs_theo(1:Nmax)
      double precision psiKj_ge_theo(1:Nmax)
      double precision psiKj_gg_theo(1:Nmax)
      double precision psiKj_theo2(1:Nmax)
      double precision psiKj_gs_theo2(1:Nmax)
      double precision psiKj_ge_theo2(1:Nmax)
      double precision psiKj_gg_theo2(1:Nmax)
      double precision dpsi_theo(1:Nmax)
      double precision dpsi_gs_theo(1:Nmax)
      double precision dpsi_ge_theo(1:Nmax)
      double precision dpsi_gg_theo(1:Nmax)
      double precision dpsiKj_theo(1:Nmax)
      double precision dpsiKj_gs_theo(1:Nmax)
      double precision dpsiKj_ge_theo(1:Nmax)
      double precision dpsiKj_gg_theo(1:Nmax)

      double precision z_f(0:Nmax),z_ft(0:2*(Nmax-1))
      double precision z_ftheo(0:Nmax)
      double precision flux_up(0:Nmax),inc_flux_up(0:Nmax)
      double precision flux_dn(0:Nmax),inc_flux_dn(0:Nmax)
      double precision flux_net(0:Nmax),inc_flux_net(0:Nmax)
      double precision flux_net_theo(0:Nmax)
      double precision flux_up_theo(0:2*(Nmax-1))
      double precision flux_dn_theo(0:2*(Nmax-1))

      double precision z(1:Nmax),psi(1:Nmax),inc_psi(1:Nmax)
      double precision psi_gs(1:Nmax),inc_psi_gs(1:Nmax)
      double precision psi_ge(1:Nmax),inc_psi_ge(1:Nmax)
      double precision psi_gg(1:Nmax),inc_psi_gg(1:Nmax)
      double precision psi2(1:Nmax),inc_psi2(1:Nmax)
      double precision psi_gs2(1:Nmax),inc_psi_gs2(1:Nmax)
      double precision psi_ge2(1:Nmax),inc_psi_ge2(1:Nmax)
      double precision psi_gg2(1:Nmax),inc_psi_gg2(1:Nmax)
      double precision dpsi(1:Nmax),inc_dpsi(1:Nmax)
      double precision dpsiKj(1:Nmax),inc_dpsiKj(1:Nmax)
      double precision dpsi_gsKj(1:Nmax),inc_dpsi_gsKj(1:Nmax)
      double precision dpsi_geKj(1:Nmax),inc_dpsi_geKj(1:Nmax)
      double precision dpsi_ggKj(1:Nmax),inc_dpsi_ggKj(1:Nmax)
      double precision psiKj(1:Nmax),inc_psiKj(1:Nmax)
      double precision psi_gsKj(1:Nmax),inc_psi_gsKj(1:Nmax)
      double precision psi_geKj(1:Nmax),inc_psi_geKj(1:Nmax)
      double precision psi_ggKj(1:Nmax),inc_psi_ggKj(1:Nmax)
      double precision psiKj2(1:Nmax),inc_psiKj2(1:Nmax)
      double precision psi_gsKj2(1:Nmax),inc_psi_gsKj2(1:Nmax)
      double precision psi_geKj2(1:Nmax),inc_psi_geKj2(1:Nmax)
      double precision psi_ggKj2(1:Nmax),inc_psi_ggKj2(1:Nmax)
      double precision dpsi_gs(1:Nmax),inc_dpsi_gs(1:Nmax)
      double precision dpsi_ge(1:Nmax),inc_dpsi_ge(1:Nmax)
      double precision dpsi_gg(1:Nmax),inc_dpsi_gg(1:Nmax)
      double precision coolr(1:Nmax),inc_coolr(1:Nmax)
      double precision z2(1:Nmax)

      real tmp1,tmp2,tmp3
      real clevs(1:2*n_cont)
      character*100 file_ray
      character*100 string_in,string_res,string_res2
      character*100 file_res,st
      integer lstin,strlen,Nb,Nq,ios,nspd,nsj
      parameter(nspd=24*3600)   ! number of seconds per day

      double precision Planck,B,B0(1:Ntmx),Tplot(1:Ntmx)
      double precision T(0:Nmax+1)
      double precision temp(0:Nmax),Tsol,Tesp
      double precision alt(0:Nmax),pres(0:Nmax)
      double precision p(0:Nmax),g(1:Nmax)
      integer cpb,zhbr,z2hbr
      double precision grav(0:Nmax),p1,p2,za,zb,beta,Cp(1:Nmax)
      double precision pne_min,pne_max
      double precision k_min,k_max
      character*100 file_out,command
      integer nlevels_pne,ncolors_ner,bw
      integer nlevels_k,ncolors_k,nlevels_flux
      integer nlevels_bilf,ncolors_bilf,ncolors_flux
      integer ncolors_ner_min,ncolors_ner_max,ncolors_ner_default
      integer shift_ner_levels
      integer ncolors_k_min,ncolors_k_max,ncolors_k_default
      integer shift_k_levels
      integer ncolors_bilf_min,ncolors_bilf_max,ncolors_bilf_default
      integer shift_bilf_levels
      integer ncolors_flux_min,ncolors_flux_max,ncolors_flux_default
      integer shift_flux_levels
      integer sign,sign_default

      integer dir_idx,if

      double precision Tblack

      nsj=24*3600

      ncolors_ner_min=3
      ncolors_ner_max=7
      ncolors_ner_default=4
      ncolors_k_min=3
      ncolors_k_max=7
      ncolors_k_default=4
      ncolors_bilf_min=3
      ncolors_bilf_max=7
      ncolors_bilf_default=4
      ncolors_flux_min=3
      ncolors_flux_max=7
      ncolors_flux_default=4
      recombine_default=0
      sign_default=1

      open(11,file='./bw')
      read(11,*) bw
      close(11)

      open(10,file='./ncolors_ner')
      read(10,*) ncolors_ner
      close(10)
      if (ncolors_ner.lt.ncolors_ner_min) then
         ncolors_ner=ncolors_ner_min
      else if (ncolors_ner.gt.ncolors_ner_max) then
         ncolors_ner=ncolors_ner_max
      endif
      if (ncolors_ner.lt.0) then
         ncolors_ner=ncolors_ner_default
      endif

      open(14,file='./ner_levels_increase')
      read(14,*) shift_ner_levels
      close(14)


      open(10,file='./ncolors_k')
      read(10,*) ncolors_k
      close(10)
      if (ncolors_k.lt.ncolors_k_min) then
         ncolors_k=ncolors_k_min
      else if (ncolors_k.gt.ncolors_k_max) then
         ncolors_k=ncolors_k_max
      endif
      if (ncolors_k.lt.0) then
         ncolors_k=ncolors_k_default
      endif

      open(14,file='./k_levels_increase')
      read(14,*) shift_k_levels


      open(10,file='./ncolors_bilf')
      read(10,*) ncolors_bilf
      close(10)
      if (ncolors_bilf.lt.ncolors_bilf_min) then
         ncolors_bilf=ncolors_bilf_min
      else if (ncolors_bilf.gt.ncolors_bilf_max) then
         ncolors_bilf=ncolors_bilf_max
      endif
      if (ncolors_bilf.lt.0) then
         ncolors_bilf=ncolors_bilf_default
      endif

      open(14,file='./bilf_levels_increase')
      read(14,*) shift_bilf_levels
      close(14)
      close(14)


      open(10,file='./ncolors_flux')
      read(10,*) ncolors_flux
      close(10)
      if (ncolors_flux.lt.ncolors_flux_min) then
         ncolors_flux=ncolors_flux_min
      else if (ncolors_flux.gt.ncolors_flux_max) then
         ncolors_flux=ncolors_flux_max
      endif
      if (ncolors_flux.lt.0) then
         ncolors_flux=ncolors_flux_default
      endif

      open(14,file='./flux_levels_increase')
      read(14,*) shift_flux_levels
      close(14)
      close(14)

      open(15,file='./recombine')
      read(15,*) recombine
      close(15)
      if ((recombine.ne.0).and.(recombine.ne.1)) then
         recombine=recombine_default
      endif

      open(16,file='./sign')
      read(16,*) sign
      close(16)
      if ((sign.ne.-1).and.(sign.ne.1)) then
         sign=sign_default
      endif

c     Dfinition des nombres de niveaux (de couleurs) dans les matrices
c     Matrice des PNE intgre:
      nlevels_pne=ncolors_ner
c     coefficients d'extinction
      nlevels_k=ncolors_k
c     bilans frquentiels
      nlevels_bilf=ncolors_bilf
c     flux frquentiels
      nlevels_flux=ncolors_flux




      cpb=1

 22   format(a)

      open(10,file='data_dir')
      read(10,22) string_in
      close(10)
      call add_slash_if_absent(string_in)
      open(11,file='results_dir')
      read(11,22) string_res
      close(11)
      call identify_dir_index(string_res,dir_idx,if)
      if (if.eq.0) then
         write(*,*) 'Error from program vizu:'
         write(*,*) 'directory index not found'
         stop
      endif
      call add_slash_if_absent(string_res)
      open(12,file='results_dir2')
      read(12,22) string_res2
      call add_slash_if_absent(string_res2)
      close(12)

      lstin=strlen(string_in)

      call read_atmos_data(m,Nb,Nq,e,lambda_lo,lambda_hi,dens,capa,
     &     grav,T,alt,temp,pres,Tsol,Tesp)
      do band=1,Nb
         no_lo(band)=1.0D+4/lambda_hi(band)
         no_hi(band)=1.0D+4/lambda_lo(band)
         nbw(band)=no_hi(band)-no_lo(band)
         lbw(band)=lambda_hi(band)-lambda_lo(band)
      enddo

c     Calcul de rho*Cp pour l'atmosphre
      p(0)=pres(0)
      do i=1,m-1
c     pres(i) est dfini  l'altitude alt(i)
c     il faut calculer p(i), la pression au niveau e(i)
         za=alt(i-1)
         zb=alt(i)
         p1=pres(i-1)
         p2=pres(i)
         if (p2.eq.0.0D+0) then
            p2=p1
         endif
         beta=dlog(p1/p2)
         p(i)=p1*dexp(-beta*(e(i)-za)/(zb-za))
         g(i)=(grav(i)+grav(i-1))/2.0D+0
         Cp(i)=(capa(i)+capa(i-1))/2.0D+0
      enddo
      p(m)=pres(m-1)
      g(m)=grav(m-1)
      Cp(m)=capa(m-1)

      do i=1,m
c     p: Pa
c     g: m/s
c     e: m
c     Cp: J/kg/K
         rhoCp(i)=(p(i-1)-p(i))/(g(i)*(e(i)-e(i-1)))*Cp(i) ! J/K/m
      enddo


c     lh=1 ! lv=1-> on trace les lignes verticales ; lv=0-> on trace pas
c     lv=0 ! lh=1-> on trace les lignes horizontales ; lv=0-> on trace pas

c     Traage des lignes verticales en fonction du nombre d'intervalles spectraux
c     pour ne pas surcharger la figure
      if (Nb.gt.Nl_mx) then
         lv=0
      else
         lv=1
      endif
c     Idem pour les lignes horizontales, mais en fonction du nombre de mailles
      if (m.gt.Nl_mx) then
         lh=0
      else
         lh=1
      endif

c     ................................................................
c     Traitement des donnes 2D
c     ................................................................

c     Temprature
      open(10,file='temperature.txt')
c      write(10,*) alt(0)/1.0D+3,pres(0)/1.0D+5,Tsol
      do i=0,m-1
         write(10,*) i+1,alt(i)/1.0D+3,pres(i)/1.0D+5,temp(i)
      enddo
c      write(10,*) alt(m-1)/1.0D+3,pres(m-1)/1.0D+5,Tesp
      close(10)

c     Pression
      open(10,file='pressure.txt')
      do i=0,m-1
         write(10,*) i+1,alt(i)/1.0D+3,pres(i)/1.0D+5
      enddo
      close(10)
      
c     ................................................................
c     Traitement des coefficients d'absorption
c     ................................................................

c     Coefficient d'absorption moyen du gaz
c     ----------------------------------------------------------------

c     Ouverture du fichier des coeff atmosphriques
      open(12,file='./ka_gaz_moy.txt',status='old',iostat=ios)
      if (ios.ne.0) then
         close(12)
         write(*,*) 'File "ka_gaz_moy.txt" could not be opened"'
      else
         do band=1,Nb
            read(12,'(1p(100e11.3))') (ka_gaz(band,i),i=1,m)
         enddo
         close(12)
         call k_extrems(m,Nb,ka_gaz,k_min,k_max)
         if (bw.eq.0) then
            file_out='cl_kag'
            call make_levels(k_min,k_max,nlevels_k,
     &           shift_k_levels,0,file_out)
            file_out='rgb_kag'
            call make_rgb_k(nlevels_k,file_out)
         else
            file_out='cl_kag_bw'
            call make_levels(k_min,k_max,nlevels_k,
     &           shift_k_levels,0,file_out)
            file_out='rgb_kag_bw'
            call make_rgb_k_bw(nlevels_k,file_out)
         endif
      endif

c     Cration du fichier de donnes ka_gaz.dat
c     Cration du fichier de contrle 'ka_gaz.ctl'
      st='ka_gaz'
      call write_dat_Nb(m,Nb,ka_gaz,sign,st)

c     paramtre de forme quivalent du gaz
c     ----------------------------------------------------------------

c     Ouverture du fichier
      open(12,file='./phi_eq.txt',status='old',iostat=ios)
      if (ios.ne.0) then
         close(12)
         write(*,*) 'File "phi_eq.txt" could not be opened"'
      else
         do band=1,Nb
            read(12,'(1p(100e11.3))') (phi_eq(band,i),i=1,m)
c            write(*,*) band
         enddo
         close(12)
         call k_extrems(m,Nb,phi_eq,k_min,k_max)
         if (bw.eq.0) then
            file_out='cl_phi_eq'
            call make_levels(k_min,k_max,nlevels_k,
     &           shift_k_levels,0,file_out)
            file_out='rgb_phi_eq'
            call make_rgb_k(nlevels_k,file_out)
         else
            file_out='cl_phi_eq_bw'
            call make_levels(k_min,k_max,nlevels_k,
     &           shift_k_levels,0,file_out)
            file_out='rgb_phi_eq_bw'
            call make_rgb_k_bw(nlevels_k,file_out)
         endif
      endif

c     Cration du fichier de donnes ka_gaz.dat
c     Cration du fichier de contrle 'ka_gaz.ctl'
      st='phi_eq_gaz'
      call write_dat_Nb(m,Nb,phi_eq,sign,st)


c     Coefficient d'absorption pour les arosols
c     ----------------------------------------------------------------

c     Ouverture du fichier des coeff. d'absorption pour les arosols
      open(12,file='./ka_aero.txt',status='old',iostat=ios)
      if (ios.ne.0) then
         close(12)
         write(*,*) 'File "ka_aero.txt" could not be opened"'
      else
         do band=1,Nb
            read(12,'(1p(100e11.3))') (ka_aero(band,i),i=1,m)
         enddo
         close(12)
         call k_extrems(m,Nb,ka_aero,k_min,k_max)
         if (bw.eq.0) then
            file_out='cl_kaa'
            call make_levels(k_min,k_max,nlevels_k,
     &           shift_k_levels,0,file_out)
            file_out='rgb_kaa'
            call make_rgb_k(nlevels_k,file_out)
         else
            file_out='cl_kaa_bw'
            call make_levels(k_min,k_max,nlevels_k,
     &           shift_k_levels,0,file_out)
            file_out='rgb_kaa_bw'
            call make_rgb_k_bw(nlevels_k,file_out)
         endif
      endif

c     Cration du fichier de donnes ka_aero.dat
c     Cration du fichier de contrle 'ka_aero.ctl'
      st='ka_aero'
      call write_dat_Nb(m,Nb,ka_aero,sign,st)


c     Coefficient d'absorption pour les nuages
c     ----------------------------------------------------------------

c     Ouverture du fichier des coeff. d'absorption pour les nuages
      open(12,file='./ka_cloud.txt',status='old',iostat=ios)
      if (ios.ne.0) then
         close(12)
         write(*,*) 'File "ka_cloud.txt" could not be opened"'
      else
         do band=1,Nb
            read(12,'(1p(100e11.3))') (ka_cloud(band,i),i=1,m)
         enddo
         close(12)
         call k_extrems(m,Nb,ka_cloud,k_min,k_max)
         if (bw.eq.0) then
            file_out='cl_kac'
            call make_levels(k_min,k_max,nlevels_k,
     &           shift_k_levels,0,file_out)
            file_out='rgb_kac'
            call make_rgb_k(nlevels_k,file_out)
         else
            file_out='cl_kac_bw'
            call make_levels(k_min,k_max,nlevels_k,
     &           shift_k_levels,0,file_out)
            file_out='rgb_kac_bw'
            call make_rgb_k_bw(nlevels_k,file_out)
         endif
      endif

c     Cration du fichier de donnes ka_gaz.dat
c     Cration du fichier de contrle 'ka_gaz.ctl'
      st='ka_cloud'
      call write_dat_Nb(m,Nb,ka_cloud,sign,st)

c     calcul des paisseurs optiques de nuage, cumules depuis le haut
c     de l'atmosphre
      do band=1,Nb
         tau_cloud(band,m)=ka_cloud(band,m)*(e(m)-e(m-1))
         do i=m-1,1,-1
            tau_cloud(band,i)=tau_cloud(band,i+1)+
     &           ka_cloud(band,i)*(e(i)-e(i-1))
         enddo
      enddo
      st='tau_cloud'
      call write_dat_Nb(m,Nb,tau_cloud,sign,st)

      open(10,file='./tau_clouds.txt')
      do i=1,m
         do band=1,Nb
            write(10,*) T(i),band,tau_cloud(band,i)
         enddo ! Nb
         write(10,*)
      enddo ! i
      close(10)


c     temp
      goto 324
c     temp

c     Coefficient d'absorption pour le continuum de co2
c     ----------------------------------------------------------------

c     Ouverture du fichier des coeff. d'absorption de continuum de co2
      open(12,file='./ka_cont_co2.txt',status='old',iostat=ios)
      if (ios.ne.0) then
         close(12)
         write(*,*) 'File "ka_cont_co2.txt" could not be opened"'
      else
         do band=1,Nb
            read(12,'(1p(100e11.3))') (ka_cont_co2(band,i),i=1,m)
c     Debug
c            write(*,*) 'band=',band,' ka_cont_co2(1)=',
c     &           ka_cont_co2(band,1)
c     Debug
         enddo
         close(12)
      endif


c     Cration du fichier de donnes ka_gaz.dat
c     Cration du fichier de contrle 'ka_gaz.ctl'
      st='ka_cont_co2'
      call write_dat_Nb(m,Nb,ka_cont_co2,sign,st)







c     Coefficient d'absorption pour le continuum de h2o
c     ----------------------------------------------------------------

c     Ouverture du fichier des coeff. d'absorption de continuum de h2o
      open(12,file='./ka_cont_h2o.txt',status='old',iostat=ios)
      if (ios.ne.0) then
         close(12)
         write(*,*) 'File "ka_cont_h2o.txt" could not be opened"'
      else
         do band=1,Nb
            read(12,'(1p(100e11.3))') (ka_cont_h2o(band,i),i=1,m)
         enddo
         close(12)
      endif

c     Cration du fichier de donnes ka_gaz.dat
c     Cration du fichier de contrle 'ka_gaz.ctl'
      st='ka_cont_h2o'
      call write_dat_Nb(m,Nb,ka_cont_h2o,sign,st)

 324  continue
c     ................................................................
c     Traitement des coefficients de diffusion
c     ................................................................


c     Coefficients de diffusion pour le gaz
c     ----------------------------------------------------------------


c     Ouverture du fichier des kd pour gaz
      open(12,file='./kd_gaz_moy.txt',status='old',iostat=ios)
      if (ios.ne.0) then
         close(12)
         write(*,*) 'File "kd_gaz_moy.txt" could not be opened"'
      else
         do band=1,Nb
            read(12,'(1p(100e11.3))') (kd_gaz(band,i),i=1,m)
         enddo
         close(12)
         call k_extrems(m,Nb,kd_gaz,k_min,k_max)
         if (bw.eq.0) then
            file_out='cl_kdg'
            call make_levels(k_min,k_max,nlevels_k,
     &           shift_k_levels,0,file_out)
            file_out='rgb_kdg'
            call make_rgb_k(nlevels_k,file_out)
         else
            file_out='cl_kdg_bw'
            call make_levels(k_min,k_max,nlevels_k,
     &           shift_k_levels,0,file_out)
            file_out='rgb_kdg_bw'
            call make_rgb_k_bw(nlevels_k,file_out)
         endif
      endif

c     Cration du fichier de donnes kd_aero.dat
c     Cration du fichier de contrle 'kd_aero.ctl'
      st='kd_gaz'
      call write_dat_Nb(m,Nb,kd_gaz,sign,st)



c     Coefficients de diffusion des arosols
c     ----------------------------------------------------------------

c     Ouverture du fichier des kd pour arosols
      open(12,file='./kd_aero.txt',status='old',iostat=ios)
      if (ios.ne.0) then
         close(12)
         write(*,*) 'File "kd_aero.txt" could not be opened"'
      else
         do band=1,Nb
            read(12,'(1p(100e11.3))') (kd_aero(band,i),i=1,m)
         enddo
         close(12)
         call k_extrems(m,Nb,kd_aero,k_min,k_max)
         if (bw.eq.0) then
            file_out='cl_kdg'
            call make_levels(k_min,k_max,nlevels_k,
     &           shift_k_levels,0,file_out)
            file_out='rgb_kdg'
            call make_rgb_k(nlevels_k,file_out)
         else
            file_out='cl_kdg_bw'
            call make_levels(k_min,k_max,nlevels_k,
     &           shift_k_levels,0,file_out)
            file_out='rgb_kdg_bw'
            call make_rgb_k_bw(nlevels_k,file_out)
         endif
      endif

c     Cration du fichier de donnes kd_aero.dat
c     Cration du fichier de contrle 'kd_aero.ctl'
      st='kd_aero'
      call write_dat_Nb(m,Nb,kd_aero,sign,st)


c     Coefficients de diffusion des nuages
c     ----------------------------------------------------------------


c     Ouverture du fichier des kd pour nuages
      open(12,file='./kd_cloud.txt',status='old',iostat=ios)
      if (ios.ne.0) then
         close(12)
         write(*,*) 'File "kd_cloud.txt" could not be opened"'
      else
         do band=1,Nb
            read(12,'(1p(100e11.3))') (kd_cloud(band,i),i=1,m)
         enddo
         close(12)
         call k_extrems(m,Nb,kd_cloud,k_min,k_max)
         if (bw.eq.0) then
            file_out='cl_kdg'
            call make_levels(k_min,k_max,nlevels_k,
     &           shift_k_levels,0,file_out)
            file_out='rgb_kdg'
            call make_rgb_k(nlevels_k,file_out)
         else
            file_out='cl_kdg_bw'
            call make_levels(k_min,k_max,nlevels_k,
     &           shift_k_levels,0,file_out)
            file_out='rgb_kdg_bw'
            call make_rgb_k_bw(nlevels_k,file_out)
         endif
      endif

c     Cration du fichier de donnes kd_cloud.dat
c     Cration du fichier de contrle 'kd_cloud.ctl'
      st='kd_cloud'
      call write_dat_Nb(m,Nb,kd_cloud,sign,st)


c     ................................................................
c     Traitement des albdos de diffusion simple
c     ................................................................


c     Albedo du gaz
c     ----------------------------------------------------------------


c     Ouverture du fichier des albedo pour les gaz
      open(12,file='./albedo_gaz.txt',status='old',iostat=ios)
      if (ios.ne.0) then
         close(12)
         write(*,*) 'File "albedo_gaz.txt" could not be opened"'
      else
         do band=1,Nb
            read(12,'(1p(100e11.3))') (omega_gaz(band,i),i=1,m)
         enddo
         close(12)
      endif

c     Cration du fichier de donnes omega_gaz.dat
c     Cration du fichier de contrle 'omega_gaz.ctl'
      st='omega_gaz'
      call write_dat_Nb(m,Nb,omega_gaz,sign,st)



c     Albedo des arosols
c     ----------------------------------------------------------------


c     Ouverture du fichier des albedo pour les arosols
      open(12,file='./albedo_aero.txt',status='old',iostat=ios)
      if (ios.ne.0) then
         close(12)
         write(*,*) 'File "albedo_aero.txt" could not be opened"'
      else
         do band=1,Nb
            read(12,'(1p(100e11.3))') (omega_aero(band,i),i=1,m)
         enddo
         close(12)
      endif

c     Cration du fichier de donnes omega_aero_d.dat
c     Cration du fichier de contrle 'omega_aero.ctl'
      st='omega_aero'
      call write_dat_Nb(m,Nb,omega_aero,sign,st)


c     Albedo des nuages
c     ----------------------------------------------------------------


c     Ouverture du fichier des albedo pour les nuages
      open(12,file='./albedo_cloud.txt',status='old',iostat=ios)
      if (ios.ne.0) then
         close(12)
         write(*,*) 'File "albedo_cloud.txt" could not be opened"'
      else
         do band=1,Nb
            read(12,'(1p(100e11.3))') (omega_cloud(band,i),i=1,m)
         enddo
         close(12)
      endif

c     Cration du fichier de donnes omega_cloud.dat
c     Cration du fichier de contrle 'omega_cloud.ctl'
      st='omega_cloud'
      call write_dat_Nb(m,Nb,omega_cloud,sign,st)


c     Albedo total (nuages+arosols)
c     ----------------------------------------------------------------


c     Ouverture du fichier des albedo totaux
      open(12,file='./albedo_total.txt',status='old',iostat=ios)
      if (ios.ne.0) then
         close(12)
         write(*,*) 'File "albedo_total.txt" could not be opened"'
      else
         do band=1,Nb
            read(12,'(1p(100e11.3))') (omega_tot(band,i),i=1,m)
         enddo
         close(12)
      endif

c     Cration du fichier de donnes omega_tot.dat
c     Cration du fichier de contrle 'omega_tot.ctl'
      st='omega_tot'
      call write_dat_Nb(m,Nb,omega_tot,sign,st)


c     ................................................................
c     Traitement des coefficients d'asymtrie
c     ................................................................


c     g du gaz
c     ----------------------------------------------------------------



c     Ouverture du fichier des g pour les gaz
      open(12,file='./g_gaz.txt',status='old',iostat=ios)
      if (ios.ne.0) then
         close(12)
         write(*,*) 'File "g_gaz.txt" could not be opened"'
      else
         do band=1,Nb
            read(12,'(1p(100e11.3))') (g_gaz(band,i),i=1,m)
         enddo
         close(12)
      endif

c     Cration du fichier de donnes g_gaz_d.dat
c     Cration du fichier de contrle 'g_gaz.ctl'
      st='g_gaz'
      call write_dat_Nb(m,Nb,g_gaz,sign,st)


c     g des arosols
c     ----------------------------------------------------------------

c     Ouverture du fichier des g pour les arosols
      open(12,file='./g_aero.txt',status='old',iostat=ios)
      if (ios.ne.0) then
         close(12)
         write(*,*) 'File "g_aero.txt" could not be opened"'
      else
         do band=1,Nb
            read(12,'(1p(100e11.3))') (g_aero(band,i),i=1,m)
         enddo
         close(12)
      endif

c     Cration du fichier de donnes g_aero_d.dat
c     Cration du fichier de contrle 'g_aero.ctl'
      st='g_aero'
      call write_dat_Nb(m,Nb,g_aero,sign,st)


c     g des nuages
c     ----------------------------------------------------------------


c     Ouverture du fichier des g pour les nuages
      open(12,file='./g_cloud.txt',status='old',iostat=ios)
      if (ios.ne.0) then
         close(12)
         write(*,*) 'File "g_cloud.txt" could not be opened"'
      else
         do band=1,Nb
            read(12,'(1p(100e11.3))') (g_cloud(band,i),i=1,m)
         enddo
         close(12)
      endif

c     Cration du fichier de donnes g_cloud_d.dat
c     Cration du fichier de contrle 'g_cloud.ctl'
      st='g_cloud'
      call write_dat_Nb(m,Nb,g_cloud,sign,st)



c     g total (nuages+arosols)
c     ----------------------------------------------------------------


c     Ouverture du fichier des g totaux
      open(12,file='./g_total.txt',status='old',iostat=ios)
      if (ios.ne.0) then
         close(12)
         write(*,*) 'File "g_total.txt" could not be opened"'
      else
         do band=1,Nb
            read(12,'(1p(100e11.3))') (g_tot(band,i),i=1,m)
         enddo
         close(12)
      endif

c     Cration du fichier de donnes g_tot.dat
c     Cration du fichier de contrle 'g_tot.ctl'
      st='g_tot'
      call write_dat_Nb(m,Nb,g_tot,sign,st)


      open(10,file='./levNb')
      write(10,*)'set ylpos 0 r'
      write(10,20)'set lon 0.5 ',dble(Nb)+0.5D+0
      write(10,20)'set z 0.5 ',dble(m)+0.5D+0
      close(10)

      open(10,file='./lev_fb')
      write(10,*)'set ylpos 0 r'
      write(10,20)'set lon 0.5 ',dble(Nb)+0.5D+0
      write(10,20)'set z 0.5 ',dble(m)+1.5D+0
      close(10)

      open(10,file='./linesNb')
c     lignes horizontales
      write(10,20)'run ligne.gs ',0.5D+0,0.5D+0,dble(Nb)+0.5D+0,
     &     0.5D+0,6.0D+0
      if (lh.eq.1) then
         do i=2,m
            write(10,20)'run ligne.gs ',0.5D+0,dble(i)-0.5D+0,
     &           dble(Nb)+0.5D+0,dble(i)-0.5D+0,1.0D+0
         enddo
      endif
c     lignes verticales
      write(10,20)'run ligne.gs ',0.5D+0,0.5D+0,0.5D+0,
     &     dble(m)+0.5D+0,6.0D+0
      if (lv.eq.1) then
         do i=2,Nb
            write(10,20)'run ligne.gs ',dble(i)-0.5D+0,0.5D+0,
     &           dble(i)-0.5D+0,dble(m)+0.5D+0,1.0D+0
         enddo
      endif
      close(10)


      open(10,file='./lines_fb')
c     lignes horizontales
      write(10,20)'run ligne.gs ',0.5D+0,0.5D+0,dble(Nb)+0.5D+0,
     &     0.5D+0,6.0D+0
      if (lh.eq.1) then
         do i=2,m+1
            write(10,20)'run ligne.gs ',0.5D+0,dble(i)-0.5D+0,
     &           dble(Nb)+0.5D+0,dble(i)-0.5D+0,1.0D+0
         enddo
      endif
c     lignes verticales
      write(10,20)'run ligne.gs ',0.5D+0,0.5D+0,0.5D+0,
     &     dble(m)+0.5D+0,6.0D+0
      if (lv.eq.1) then
         do i=2,Nb
            write(10,20)'run ligne.gs ',dble(i)-0.5D+0,0.5D+0,
     &           dble(i)-0.5D+0,dble(m)+1.5D+0,1.0D+0
         enddo
      endif
      close(10)


c***************************************************************************
c     VISUALISATION DES RESULTATS
c***************************************************************************

      open(10,file='./levm')
      write(10,*)'set ylpos 0 l'
      write(10,20)'set lon -0.5 ',dble(m)+2.0D+0-0.5D+0
      write(10,20)'set z 0.5 ',dble(m)+2.0D+0+0.5D+0
      close(10)

      open(10,file='./linesm')
c     lignes horizontales
      do i=1,m+2
         if ((i.eq.1).or.(i.eq.m+1)) then
            j=6
         else
            j=1
         endif
         if ((lh.eq.1).or.(i.eq.1).or.(i.eq.m+1)) then
            write(10,20)'run ligne.gs ',-0.5D+0,dble(i)-0.5D+0,
     &           dble(m)+2.0D+0-0.5D+0,dble(i)-0.5D+0,dble(j)
         endif
      enddo
c     lignes verticales
      do i=1,m+2
         if ((i.eq.1).or.(i.eq.m+1)) then
            j=6
         else
            j=1
         endif
         if ((lv.eq.1).or.(i.eq.1).or.(i.eq.m+1)) then
            write(10,20)'run ligne.gs ',dble(i)-0.5D+0,-0.5D+0,
     &           dble(i)-0.5D+0,dble(m)+2.0D+0-0.5D+0,dble(j)
         endif
      enddo
      close(10)

c     ................................................................
c     Traitement des PNE
c     ................................................................


c     Ouverture du fichier des PNE et lecture des rsultats du code MC
c     Debug
c     write(*,*) 'opening PNEsym 1'
c     write(*,*) 'm=',m
c     Debug
      if (recombine.eq.0) then
         file_res=string_res(1:strlen(string_res))//
     &        'PNEsym.txt'
      else
         file_res=string_res(1:strlen(string_res))//
     &        'rPNEsym.txt'
      endif
      open(12,file=file_res,status='old',iostat=ios)
      if (ios.ne.0) then
         close(12)
         write(*,*) 'File "',file_res,'" could not be opened"'
      else
         do i=0,m+1
            do j=0,m+1
               read(12,*) tPNEsym(i,j),inc_tPNEsym(i,j)
            enddo
         enddo
         close(12)
         call pne_extrems(m,tPNEsym,pne_min,pne_max)
         if (bw.eq.0) then
            file_out='cl_pne'
            call make_levels(pne_min,pne_max,nlevels_pne,
     &           shift_ner_levels,1,file_out)
            file_out='rgb_pne'
            call make_rgb_ner(nlevels_pne,file_out)
         else
            file_out='cl_pne_bw'
            call make_levels(pne_min,pne_max,nlevels_pne,
     &           shift_ner_levels,1,file_out)
            file_out='rgb_pne_bw'
            call make_rgb_ner_bw(nlevels_pne,file_out)
         endif
      endif

c     Lecture des PNE(sol,i)1 et PNE(espace,i)1 par bande
c     les PNE sont donnes en W/m/cm
      if (recombine.eq.0) then
         file_res=string_res(1:strlen(string_res))//
     &        'PNE_mono-nu_theo.txt'
      else
         file_res=string_res(1:strlen(string_res))//
     &        'rPNE_mono-nu_theo.txt'
      endif
      open(12,file=file_res,status='old',iostat=ios)
      if (ios.ne.0) then
         close(12)
         write(*,*) 'File "',file_res,'" could not be opened"'
      else
         read(12,*)
         do band=1,Nb
            read(12,*)
            read(12,50) (pne_si1(i,band),i=0,m+1) ! W/m/cm
            do i=1,m
               read(12,50)
            enddo
            read(12,50) (pne_ei1(i,band),i=0,m+1) ! W/m/cm
         enddo
         close(12)
      endif

c     Lecture des PNE(sol,i)2 et PNE(espace,i)2 par bande
      if (recombine.eq.0) then
         file_res=string_res2(1:strlen(string_res2))//
     &        'PNE_mono-nu_theo.txt'
      else
         file_res=string_res2(1:strlen(string_res2))//
     &        'rPNE_mono-nu_theo.txt'
      endif
      open(12,file=file_res,status='old',iostat=ios)
      if (ios.ne.0) then
         close(12)
         write(*,*) 'File "',file_res,'" could not be opened"'
      else
         read(12,*)
         do band=1,Nb
            read(12,*)
            read(12,50) (pne_si2(i,band),i=0,m+1)
            do i=1,m
               read(12,50)
            enddo
            read(12,50) (pne_ei2(i,band),i=0,m+1)
         enddo
         close(12)
      endif

 4215 continue

c     Calcul des bilans sol et espace, et des diffrences
      open(10,file='bilan_sol_freq_theo.txt')
      open(11,file='bilan_esp_freq_theo.txt')
      dbil_sol_int=0.0D+0
      dbil_esp_int=0.0D+0
      dbil_sg_int=0.0D+0
      dbil_se_int=0.0D+0
      dbil_ge_int=0.0D+0

      do band=1,Nb
         bil_sol1(band)=0.0D+0
         do i=0,m
            bil_sol1(band)=bil_sol1(band)+pne_si1(i,band) ! W/m/cm
         enddo
         bil_sol_sg1(band)=bil_sol1(band) ! W/m/cm
         bil_sol_se1(band)=pne_si1(m+1,band) ! W/m/cm
         bil_sol1(band)=bil_sol_sg1(band)+bil_sol_se1(band) ! W/m/cm

         bil_sol2(band)=0.0D+0
         do i=0,m
            bil_sol2(band)=bil_sol2(band)+pne_si2(i,band) ! W/m/cm
         enddo
         bil_sol_sg2(band)=bil_sol2(band) ! W/m/cm
         bil_sol_se2(band)=pne_si2(m+1,band) ! W/m/cm
         bil_sol2(band)=bil_sol_sg2(band)+bil_sol_se2(band) ! W/m/cm
         
         bil_esp1(band)=0.0D+0
         do i=1,m+1
            bil_esp1(band)=bil_esp1(band)+pne_ei1(i,band) ! W/m/cm
         enddo
         bil_esp_eg1(band)=bil_esp1(band) ! W/m/cm
         bil_esp_es1(band)=pne_ei1(0,band) ! W/m/cm
         bil_esp1(band)=bil_esp_eg1(band)+bil_esp_es1(band) ! W/m/cm
         
         bil_esp2(band)=0.0D+0
         do i=1,m+1
            bil_esp2(band)=bil_esp2(band)+pne_ei2(i,band) ! W/m/cm
         enddo
         bil_esp_eg2(band)=bil_esp2(band) ! W/m/cm
         bil_esp_es2(band)=pne_ei2(0,band) ! W/m/cm
         bil_esp2(band)=bil_esp_eg2(band)+bil_esp_es2(band) ! W/m/cm

         dbil_sol(band)=bil_sol2(band)-bil_sol1(band) ! W/m2/cm-1
         if (dabs(dbil_sol(band)).lt.1.0D-50) then
            dbil_sol(band)=0.0D+0
         endif
         dbil_sol(band)=dbil_sol(band)*nbw(band)/lbw(band) ! W/m2/m

         dbil_sol_sg(band)=bil_sol_sg2(band)-bil_sol_sg1(band) ! W/m2/cm-1
         if (dabs(dbil_sol_sg(band)).lt.1.0D-50) then
            dbil_sol_sg(band)=0.0D+0
         endif
         dbil_sol_sg(band)=dbil_sol_sg(band)*nbw(band)/lbw(band) ! W/m2/m

         dbil_sol_se(band)=bil_sol_se2(band)-bil_sol_se1(band) ! W/m2/cm-1
         if (dabs(dbil_sol_se(band)).lt.1.0D-50) then
            dbil_sol_se(band)=0.0D+0
         endif
         dbil_sol_se(band)=dbil_sol_se(band)*nbw(band)/lbw(band) ! W/m2/m

         dbil_esp(band)=bil_esp2(band)-bil_esp1(band) ! W/m2/cm-1
         if (dabs(dbil_esp(band)).lt.1.0D-50) then
            dbil_esp(band)=0.0D+0
         endif
         dbil_esp(band)=dbil_esp(band)*nbw(band)/lbw(band) ! W/m2/m

         dbil_esp_eg(band)=bil_esp_eg2(band)-bil_esp_eg1(band) ! W/m2/cm-1
         if (dabs(dbil_esp_eg(band)).lt.1.0D-50) then
            dbil_esp_eg(band)=0.0D+0
         endif
         dbil_esp_eg(band)=dbil_esp_eg(band)*nbw(band)/lbw(band) ! W/m2/m

         dbil_esp_es(band)=bil_esp_es2(band)-bil_esp_es1(band) ! W/m2/cm-1
         if (dabs(dbil_esp_es(band)).lt.1.0D-50) then
            dbil_esp_es(band)=0.0D+0
         endif
         dbil_esp_es(band)=dbil_esp_es(band)*nbw(band)/lbw(band) ! W/m2/m

         dbil_sol_int=dbil_sol_int+dbil_sol(band)
     &        *(lbw(band)) ! W/m2
         dbil_esp_int=dbil_esp_int+dbil_esp(band)
     &        *(lbw(band)) ! W/m2

         dbil_sg_int=dbil_sg_int+dbil_sol_sg(band)
     &        *(lbw(band)) ! W/m2
         dbil_se_int=dbil_se_int+dbil_sol_se(band)
     &        *(lbw(band)) ! W/m2
         dbil_ge_int=dbil_ge_int+dbil_esp_eg(band)
     &        *(lbw(band)) ! W/m2
         
c     colonne1: numro de bande troite
c     colonne2: longueur d'onde (m)
c     colonne3: bilan total du sol en W/m/m
c     colonne4: bilan total du sol d aux changes sol-gaz en W/m/m
c     colonne5: bilan total du sol d aux changes sol-esp en W/m/m
c     colonne6: bilan total du sol en W/m/cm-1
c     colonne7: bilan total du sol d aux changes sol-gaz en W/m/cm-1
c     colonne8: bilan total du sol d aux changes sol-esp en W/m/cm-1
         write(10,41) band,lambda_lo(band),
     &        dbil_sol(band), ! W/m/m
     &        dbil_sol_sg(band), ! W/m/m
     &        dbil_sol_se(band), ! W/m/m
     &        dbil_sol(band)*lbw(band)/nbw(band), ! W/m/cm-1
     &        dbil_sol_sg(band)*lbw(band)/nbw(band), ! W/m/cm-1
     &        dbil_sol_se(band)*lbw(band)/nbw(band) ! W/m/cm-1
         write(10,41) band,lambda_hi(band),
     &        dbil_sol(band), ! W/m/m
     &        dbil_sol_sg(band), ! W/m/m
     &        dbil_sol_se(band), ! W/m/m
     &        dbil_sol(band)*lbw(band)/nbw(band), ! W/m/cm-1
     &        dbil_sol_sg(band)*lbw(band)/nbw(band), ! W/m/cm-1
     &        dbil_sol_se(band)*lbw(band)/nbw(band) ! W/m/cm-1
         
c     colonne1: numro de bande troite
c     colonne2: longueur d'onde (m)
c     colonne3: bilan total de l'espace en W/m/m
c     colonne4: bilan total de l'espace d aux changes esp-gaz en W/m/m
c     colonne5: bilan total de l'espace d aux changes esp-sol en W/m/m
c     colonne3: bilan total de l'espace en W/m/cm
c     colonne4: bilan total de l'espace d aux changes esp-gaz en W/m/cm
c     colonne5: bilan total de l'espace d aux changes esp-sol en W/m/cm
         write(11,41) band,lambda_lo(band),
     &        dbil_esp(band), ! W/m/m
     &        dbil_esp_eg(band), ! W/m/m
     &        dbil_esp_es(band), ! W/m/m
     &        dbil_esp(band)*lbw(band)/nbw(band),
     &        dbil_esp_eg(band)*lbw(band)/nbw(band),
     &        dbil_esp_es(band)*lbw(band)/nbw(band)
         write(11,41) band,lambda_hi(band),
     &        dbil_esp(band), ! W/m/m
     &        dbil_esp_eg(band), ! W/m/m
     &        dbil_esp_es(band), ! W/m/m
     &        dbil_esp(band)*lbw(band)/nbw(band), ! W/m/cm-1
     &        dbil_esp_eg(band)*lbw(band)/nbw(band), ! W/m/cm-1
     &        dbil_esp_es(band)*lbw(band)/nbw(band) ! W/m/cm-1

      enddo
      close(10)
      close(11)

c     Debug
      write(*,*) 'delta(integrated ground budget)=',dbil_sol_int,' W/m'
      write(*,*) 'delta(integrated space budget)=',dbil_esp_int,' W/m'
      write(*,*) 'delta(integrated ground-gas budget)=',dbil_sg_int,
     &     ' W/m'
      write(*,*) 'delta(integrated ground-space budget)=',dbil_se_int,
     &     ' W/m'
      write(*,*) 'delta(integrated gas-space budget)=',dbil_ge_int,
     &     ' W/m'
c     Debug

c     Cration du fichier de donnes pne.dat
c     Cration du fichier de contrle 'pne.ctl'
      st='pne'
      call write_dat_m(m,tPNEsym,sign,st)
c     Cration du fichier de donnes inc_pne.dat
c     Cration du fichier de contrle 'inc_pne.ctl'
      st='inc_pne'
      call write_dat_m(m,inc_tPNEsym,sign,st)

c     ................................................................
c     Traitement des diffrences de PNE
c     ................................................................


c     Ouverture du fichier des PNE et lecture des rsultats du code MC
c     Debug
c     write(*,*) 'opening PNEsym 2'
c     Debug
      if (recombine.eq.0) then
         file_res=string_res2(1:strlen(string_res2))//
     &        'PNEsym.txt'
      else
         file_res=string_res2(1:strlen(string_res2))//
     &        'rPNEsym.txt'
      endif
      open(12,file=file_res,status='old',iostat=ios)
      if (ios.ne.0) then
         close(12)
         write(*,*) 'File "',file_res,'" could not be opened"'
      else
         do i=0,m+1
            do j=0,m+1
               read(12,*) tPNEsym2(i,j),inc_tPNEsym2(i,j)
               dtPNEsym(i,j)=tPNEsym2(i,j)-tPNEsym(i,j)
               inc_dtPNEsym(i,j)=inc_tPNEsym2(i,j)+inc_tPNEsym(i,j)
            enddo
         enddo
         close(12)
         call pne_extrems(m,dtPNEsym,pne_min,pne_max)
         if (bw.eq.0) then
            file_out='cl_dpne'
            call make_levels(pne_min,pne_max,nlevels_pne,
     &           shift_ner_levels,1,file_out)
c     Debug
c            write(*,*) 'ok with shift_ner_levels=',shift_ner_levels
c            read(*,*)
c     Debug
            file_out='rgb_dpne'
            call make_rgb_ner(nlevels_pne,file_out)
         else
            file_out='cl_dpne_bw'
            call make_levels(pne_min,pne_max,nlevels_pne,
     &           shift_ner_levels,1,file_out)
            file_out='rgb_dpne_bw'
            call make_rgb_ner_bw(nlevels_pne,file_out)
         endif
      endif

c     Cration du fichier de donnes dpne.dat
c     Cration du fichier de contrle 'dpne.ctl'
      st='dpne'
      call write_dat_m(m,dtPNEsym,sign,st)
c     Cration du fichier de donnes inc_dpne.dat
c     Cration du fichier de contrle 'inc_dpne.ctl'
      st='inc_dpne'
      call write_dat_m(m,inc_dtPNEsym,sign,st)


c     ................................................................
c     Traitement des PNE analytiques
c     ................................................................

c     Ouverture du fichier des PNE analytiques
      if (recombine.eq.0) then
         file_res=string_res(1:strlen(string_res))//
     &        'PNEtheo.txt'
      else
         file_res=string_res(1:strlen(string_res))//
     &        'rPNEtheo.txt'
      endif
      open(12,file=file_res,status='old',iostat=ios)
      if (ios.ne.0) then
         close(12)
         write(*,*) 'File "',file_res,'" could not be opened"'
      else
         do i=0,m+1
            do j=0,m+1
               read(12,*) tPNEtheo(i,j)
            enddo
         enddo
         close(12)
         call pne_extrems(m,tPNEtheo,pne_min,pne_max)
c     Debug
c         write(*,*) pne_min,pne_max
c         read(*,*)
c     Debug
         if (bw.eq.0) then
            file_out='cl_pnea'
            call make_levels(pne_min,pne_max,nlevels_pne,
     &           shift_ner_levels,1,file_out)
            file_out='rgb_pnea'
            call make_rgb_ner(nlevels_pne,file_out)
         else
            file_out='cl_pnea_bw'
            call make_levels(pne_min,pne_max,nlevels_pne,
     &           shift_ner_levels,1,file_out)
            file_out='rgb_pnea_bw'
            call make_rgb_ner_bw(nlevels_pne,file_out)
         endif
      endif
c     Cration du fichier de donnes pne_theo.dat
c     Cration du fichier de contrle 'pne_theo.ctl'
      st='pne_theo'
      call write_dat_m(m,tPNEtheo,sign,st)

c     ................................................................
c     Traitement des diffrences de PNE analytiques
c     ................................................................

c     Ouverture du fichier des PNE analytiques
      if (recombine.eq.0) then
         file_res=string_res2(1:strlen(string_res2))//
     &        'PNEtheo.txt'
      else
         file_res=string_res2(1:strlen(string_res2))//
     &        'rPNEtheo.txt'
      endif
      open(12,file=file_res,status='old',iostat=ios)
      if (ios.ne.0) then
         close(12)
         write(*,*) 'File "',file_res,'" could not be opened"'
      else
         do i=0,m+1
            do j=0,m+1
               read(12,*) tPNEtheo2(i,j)
               dtPNEtheo(i,j)=tPNEtheo2(i,j)-tPNEtheo(i,j)
            enddo
         enddo
         close(12)
         call pne_extrems(m,dtPNEtheo,pne_min,pne_max)
         if (bw.eq.0) then
            file_out='cl_dpnea'
            call make_levels(pne_min,pne_max,nlevels_pne,
     &           shift_ner_levels,1,file_out)
            file_out='rgb_dpnea'
            call make_rgb_ner(nlevels_pne,file_out)
         else
            file_out='cl_dpnea_bw'
            call make_levels(pne_min,pne_max,nlevels_pne,
     &           shift_ner_levels,1,file_out)
            file_out='rgb_dpnea_bw'
            call make_rgb_ner_bw(nlevels_pne,file_out)
         endif
      endif
c     Cration du fichier de donnes dpne_theo.dat
c     Cration du fichier de contrle 'dpne_theo.ctl'
      st='dpne_theo'
      call write_dat_m(m,dtPNEtheo,sign,st)


c     ................................................................
c     Diffrences de PNE MC - PNE analytiques
c     ................................................................
      do i=0,m+1
         do j=0,m+1
            sdtPNE(i,j)=tPNEsym(i,j)-tPNEtheo(i,j)
         enddo
      enddo
      call pne_extrems(m,sdtPNE,pne_min,pne_max)
      if (bw.eq.0) then
         file_out='cl_sdpne'
         call make_levels(pne_min,pne_max,nlevels_pne,
     &        shift_ner_levels,1,file_out)
         file_out='rgb_sdpne'
         call make_rgb_ner(nlevels_pne,file_out)
      else
         file_out='cl_sdpne_bw'
         call make_levels(pne_min,pne_max,nlevels_pne,
     &        shift_ner_levels,1,file_out)
         file_out='rgb_sdpne_bw'
         call make_rgb_ner_bw(nlevels_pne,file_out)
      endif
c     Cration du fichier de donnes sdpne_theo.dat
c     Cration du fichier de contrle 'sdpne_theo.ctl'
      st='sdpne'
      call write_dat_m(m,sdtPNE,sign,st)

c     ................................................................
c     Traitement des Cooling Rates
c     ................................................................

c     Ouverture du fichier des CR et lecture des rsultats du code MC
      file_res=string_res(1:strlen(string_res))//'CR.txt'
      open(12,file=file_res,status='old',iostat=ios)
      if (ios.ne.0) then
         close(12)
         write(*,*) 'File "',file_res,'" could not be opened"'
      else
         do i=0,m+1
            do j=0,m+1
               read(12,*) CR(i,j),inc_CR(i,j)
            enddo
         enddo
         close(12)
         call pne_extrems(m,CR,pne_min,pne_max)
         if (bw.eq.0) then
            file_out='cl_cr'
            call make_levels(pne_min,pne_max,nlevels_pne,
     &           shift_ner_levels,1,file_out)
            file_out='rgb_cr'
            call make_rgb_ner(nlevels_pne,file_out)
         else
            file_out='cl_cr_bw'
            call make_levels(pne_min,pne_max,nlevels_pne,
     &           shift_ner_levels,1,file_out)
            file_out='rgb_cr_bw'
            call make_rgb_ner_bw(nlevels_pne,file_out)
         endif
      endif

c     Cration du fichier de donnes CR.dat
c     Cration du fichier de contrle 'CR.ctl'
      st='CR'
      call write_dat_m(m,CR,sign,st)
c     Cration du fichier de donnes CR.dat
c     Cration du fichier de contrle 'CR.ctl'
      st='inc_CR'
      call write_dat_m(m,inc_CR,sign,st)

c     ................................................................
c     Traitement des Cooling Rates analytiques
c     ................................................................

c     Ouverture du fichier des CR analytiques
      file_res=string_res(1:strlen(string_res))//'CR_theo.txt'
      open(12,file=file_res,status='old',iostat=ios)
      if (ios.ne.0) then
         close(12)
         write(*,*) 'File "',file_res,'" could not be opened"'
      else
         do i=0,m+1
            do j=0,m+1
               read(12,*) CR_theo(i,j)
            enddo
         enddo
         close(12)
         call pne_extrems(m,CR,pne_min,pne_max)
         if (bw.eq.0) then
            file_out='cl_cra'
            call make_levels(pne_min,pne_max,nlevels_pne,
     &           shift_ner_levels,1,file_out)
            file_out='rgb_cra'
            call make_rgb_ner(nlevels_pne,file_out)
         else
            file_out='cl_cra_bw'
            call make_levels(pne_min,pne_max,nlevels_pne,
     &           shift_ner_levels,1,file_out)
            file_out='rgb_cra_bw'
            call make_rgb_ner_bw(nlevels_pne,file_out)
         endif
      endif
c     Cration du fichier de donnes CR_theo.dat
c     Cration du fichier de contrle 'CR_theo.ctl'
      st='CR_theo'
      call write_dat_m(m,CR_theo,sign,st)


c     ................................................................
c     Traitement des bilans frquentiels totaux et de leurs incertitudes
c     ................................................................
      
      if (recombine.eq.0) then
         file_res=string_res(1:strlen(string_res))//
     &        'bilans_freq.txt'
      else
         file_res=string_res(1:strlen(string_res))//
     &        'rbilans_freq.txt'
      endif
      open(10,file=file_res,status='old',iostat=ios)
      if (ios.ne.0) then
         close(10)
         write(*,*) 'File "',file_res,'" could not be opened"'
      else
         do band=1,Nb
            read(10,50) (bil_freq_tot(band,i),i=1,m) ! mW/m
            do i=1,m
c     bil_freq_tot: mW/m
c     rhoCp: J/m/K
               bilkj_freq_tot(band,i)=bil_freq_tot(band,i)
     &              *nsj/rhoCp(i)/1.0D+3
c     bilkj_freq_tot: K/j
            enddo
         enddo
         close(10)
         call k_extrems(m,Nb,bil_freq_tot,k_min,k_max)
         if (bw.eq.0) then
            file_out='cl_bf'
            call make_levels(k_min,k_max,nlevels_bilf,
     &           shift_bilf_levels,1,file_out)
            file_out='rgb_bilf'
            call make_rgb_ner(nlevels_bilf,file_out)
         else
            file_out='cl_bf_bw'
            call make_levels(k_min,k_max,nlevels_bilf,
     &           shift_bilf_levels,1,file_out)
            file_out='rgb_bilf_bw'
            call make_rgb_ner_bw(nlevels_bilf,file_out)
         endif
      endif
c     Cration du fichier de donnes bilan_tot.dat
c     Cration du fichier de contrle 'bilan_tot.ctl'
      st='bilan_tot'
      call write_dat_Nb(m,Nb,bil_freq_tot,sign,st)
      st='bilankj_tot'
      call write_dat_Nb(m,Nb,bilkj_freq_tot,sign,st)

      if (recombine.eq.0) then
         file_res=string_res(1:strlen(string_res))//
     &        'inc_bilans_freq.txt'
      else
         file_res=string_res(1:strlen(string_res))//
     &        'inc_rbilans_freq.txt'
      endif
      open(11,file=file_res,status='old',iostat=ios)
      if (ios.ne.0) then
         close(11)
         write(*,*) 'File "',file_res,'" could not be opened"'
      else
         do band=1,Nb
            read(11,50) (inc_bil_freq_tot(band,i),i=1,m)
            do i=1,m
               inc_bilkj_freq_tot(band,i)=inc_bil_freq_tot(band,i)
     &              *nsj/rhoCp(i)/1.0D+3 ! K/j
            enddo
         enddo
         close(11)
         call k_extrems(m,Nb,inc_bil_freq_tot,k_min,k_max)
         if (bw.eq.0) then
            file_out='cl_ibf'
            call make_levels(k_min,k_max,nlevels_bilf,
     &           shift_bilf_levels,1,file_out)
            file_out='rgb_ibilf'
            call make_rgb_ner(nlevels_bilf,file_out)
         else
            file_out='cl_ibf_bw'
            call make_levels(k_min,k_max,nlevels_bilf,
     &           shift_bilf_levels,1,file_out)
            file_out='rgb_ibilf_bw'
            call make_rgb_ner_bw(nlevels_bilf,file_out)
         endif
      endif
c     Cration du fichier de donnes inc_bilan_tot.dat
c     Cration du fichier de contrle 'inc_bilan_tot.ctl'
      st='inc_bilan_tot'
      call write_dat_Nb(m,Nb,inc_bil_freq_tot,sign,st)
      st='inc_bilankj_tot'
      call write_dat_Nb(m,Nb,inc_bilkj_freq_tot,sign,st)


      if (recombine.eq.0) then
         file_res=string_res2(1:strlen(string_res2))//
     &        'bilans_freq.txt'
      else
         file_res=string_res2(1:strlen(string_res2))//
     &        'rbilans_freq.txt'
      endif
      open(10,file=file_res,status='old',iostat=ios)
      if (ios.ne.0) then
         close(10)
         write(*,*) 'File "',file_res,'" could not be opened"'
      else
         do band=1,Nb
            read(10,50) (bil_freq_tot2(band,i),i=1,m)
            do i=1,m
               dbil_freq_tot(band,i)=bil_freq_tot2(band,i)-
     &              bil_freq_tot(band,i)
               dbilkj_freq_tot(band,i)=dbil_freq_tot(band,i)
     &              *nsj/rhoCp(i)/1.0D+3 ! K/j
            enddo
         enddo
         close(10)
         call k_extrems(m,Nb,dbil_freq_tot,k_min,k_max)
         if (bw.eq.0) then
            file_out='cl_dbf'
            call make_levels(k_min,k_max,nlevels_bilf,
     &           shift_bilf_levels,1,file_out)
            file_out='rgb_dbilf'
            call make_rgb_ner(nlevels_bilf,file_out)
         else
            file_out='cl_dbf_bw'
            call make_levels(k_min,k_max,nlevels_bilf,
     &           shift_bilf_levels,1,file_out)
            file_out='rgb_dbilf_bw'
            call make_rgb_ner_bw(nlevels_bilf,file_out)
         endif
      endif
c     Cration du fichier de donnes bilan_tot.dat
c     Cration du fichier de contrle 'bilan_tot.ctl'
      st='dbilan_tot'
      call write_dat_Nb(m,Nb,dbil_freq_tot,sign,st)
      st='dbilankj_tot'
      call write_dat_Nb(m,Nb,dbilkj_freq_tot,sign,st)



c     ................................................................
c     Traitement des bilans frquentiels gaz-sol et de leurs incertitudes
c     ................................................................
      
      if (recombine.eq.0) then
         file_res=string_res(1:strlen(string_res))//
     &        'bilans_freq_gs.txt'
      else
         file_res=string_res(1:strlen(string_res))//
     &        'rbilans_freq_gs.txt'
      endif
      open(10,file=file_res,status='old',iostat=ios)
      if (ios.ne.0) then
         close(10)
         write(*,*) 'File "',file_res,'" could not be opened"'
      else
         do band=1,Nb
            read(10,50) (bil_freq_gs(band,i),i=1,m)
            do i=1,m
               bilkj_freq_gs(band,i)=bil_freq_gs(band,i)
     &              *nsj/rhoCp(i)/1.0D+3 ! K/j
            enddo
         enddo
         close(10)
         call k_extrems(m,Nb,bil_freq_gs,k_min,k_max)
         if (bw.eq.0) then
            file_out='cl_bfgs'
            call make_levels(k_min,k_max,nlevels_bilf,
     &           shift_bilf_levels,1,file_out)
            file_out='rgb_bilfgs'
            call make_rgb_ner(nlevels_bilf,file_out)
         else
            file_out='cl_bfgs_bw'
            call make_levels(k_min,k_max,nlevels_bilf,
     &           shift_bilf_levels,1,file_out)
            file_out='rgb_bilfgs_bw'
            call make_rgb_ner_bw(nlevels_bilf,file_out)
         endif
      endif
c     Cration du fichier de donnes bilan_gs.dat
c     Cration du fichier de contrle 'bilan_gs.ctl'
      st='bilan_gs'
      call write_dat_Nb(m,Nb,bil_freq_gs,sign,st)
      st='bilankj_gs'
      call write_dat_Nb(m,Nb,bilkj_freq_gs,sign,st)


      if (recombine.eq.0) then
         file_res=string_res(1:strlen(string_res))//
     &        'inc_bilans_freq_gs.txt'
      else
         file_res=string_res(1:strlen(string_res))//
     &        'inc_rbilans_freq_gs.txt'
      endif
      open(11,file=file_res,status='old',iostat=ios)
      if (ios.ne.0) then
         close(11)
         write(*,*) 'File "',file_res,'" could not be opened"'
      else
         do band=1,Nb
            read(11,50) (inc_bil_freq_gs(band,i),i=1,m)
            do i=1,m
               inc_bilkj_freq_gs(band,i)=inc_bil_freq_gs(band,i)
     &              *nsj/rhoCp(i)/1.0D+3 ! K/j
            enddo
         enddo
         close(11)
         call k_extrems(m,Nb,inc_bil_freq_gs,k_min,k_max)
         if (bw.eq.0) then
            file_out='cl_ibfgs'
            call make_levels(k_min,k_max,nlevels_bilf,
     &           shift_bilf_levels,1,file_out)
            file_out='rgb_ibilfgs'
            call make_rgb_ner(nlevels_bilf,file_out)
         else
            file_out='cl_ibfgs_bw'
            call make_levels(k_min,k_max,nlevels_bilf,
     &           shift_bilf_levels,1,file_out)
            file_out='rgb_ibilfgs_bw'
            call make_rgb_ner_bw(nlevels_bilf,file_out)
         endif
      endif
c     Cration du fichier de donnes inc_bilan_gs.dat
c     Cration du fichier de contrle 'inc_bilan_gs.ctl'
      st='inc_bilan_gs'
      call write_dat_Nb(m,Nb,inc_bil_freq_gs,sign,st)
      st='inc_bilankj_gs'
      call write_dat_Nb(m,Nb,inc_bilkj_freq_gs,sign,st)
      
      if (recombine.eq.0) then
         file_res=string_res2(1:strlen(string_res2))//
     &        'bilans_freq_gs.txt'
      else
         file_res=string_res2(1:strlen(string_res2))//
     &        'rbilans_freq_gs.txt'
      endif
      open(10,file=file_res,status='old',iostat=ios)
      if (ios.ne.0) then
         close(10)
         write(*,*) 'File "',file_res,'" could not be opened"'
      else
         do band=1,Nb
            read(10,50) (bil_freq_gs2(band,i),i=1,m)
            do i=1,m
               dbil_freq_gs(band,i)=bil_freq_gs2(band,i)-
     &              bil_freq_gs(band,i)
               dbilkj_freq_gs(band,i)=dbil_freq_gs(band,i)
     &              *nsj/rhoCp(i)/1.0D+3 ! K/j
            enddo
         enddo
         close(10)
         call k_extrems(m,Nb,dbil_freq_gs,k_min,k_max)
         if (bw.eq.0) then
            file_out='cl_dbfgs'
            call make_levels(k_min,k_max,nlevels_bilf,
     &           shift_bilf_levels,1,file_out)
            file_out='rgb_dbilfgs'
            call make_rgb_ner(nlevels_bilf,file_out)
         else
            file_out='cl_dbfgs_bw'
            call make_levels(k_min,k_max,nlevels_bilf,
     &           shift_bilf_levels,1,file_out)
            file_out='rgb_dbilfgs_bw'
            call make_rgb_ner_bw(nlevels_bilf,file_out)
         endif
      endif
c     Cration du fichier de donnes bilan_gs.dat
c     Cration du fichier de contrle 'bilan_gs.ctl'
      st='dbilan_gs'
      call write_dat_Nb(m,Nb,dbil_freq_gs,sign,st)
      st='dbilankj_gs'
      call write_dat_Nb(m,Nb,dbilkj_freq_gs,sign,st)



c     ................................................................
c     Traitement des bilans frquentiels gaz-espace et de leurs incertitudes
c     ................................................................
      
      if (recombine.eq.0) then
         file_res=string_res(1:strlen(string_res))//
     &        'bilans_freq_ge.txt'
      else
         file_res=string_res(1:strlen(string_res))//
     &        'rbilans_freq_ge.txt'
      endif
      open(10,file=file_res,status='old',iostat=ios)
      if (ios.ne.0) then
         close(10)
         write(*,*) 'File "',file_res,'" could not be opened"'
      else
         do band=1,Nb
            read(10,50) (bil_freq_ge(band,i),i=1,m)
            do i=1,m
               bilkj_freq_ge(band,i)=bil_freq_ge(band,i)
     &              *nsj/rhoCp(i)/1.0D+3 ! K/j
            enddo
         enddo
         close(10)
         call k_extrems(m,Nb,bil_freq_ge,k_min,k_max)
         if (bw.eq.0) then
            file_out='cl_bfge'
            call make_levels(k_min,k_max,nlevels_bilf,
     &           shift_bilf_levels,1,file_out)
            file_out='rgb_bilfge'
            call make_rgb_ner(nlevels_bilf,file_out)
         else
            file_out='cl_bfge_bw'
            call make_levels(k_min,k_max,nlevels_bilf,
     &           shift_bilf_levels,1,file_out)
            file_out='rgb_bilfge_bw'
            call make_rgb_ner_bw(nlevels_bilf,file_out)
         endif
      endif
c     Cration du fichier de donnes bilan_ge.dat
c     Cration du fichier de contrle 'bilan_ge.ctl'
      st='bilan_ge'
      call write_dat_Nb(m,Nb,bil_freq_ge,sign,st)
      st='bilankj_ge'
      call write_dat_Nb(m,Nb,bilkj_freq_ge,sign,st)


      if (recombine.eq.0) then
         file_res=string_res(1:strlen(string_res))//
     &        'inc_bilans_freq_ge.txt'
      else
         file_res=string_res(1:strlen(string_res))//
     &        'inc_rbilans_freq_ge.txt'
      endif
      open(11,file=file_res,status='old',iostat=ios)
      if (ios.ne.0) then
         close(11)
         write(*,*) 'File "',file_res,'" could not be opened"'
      else
         do band=1,Nb
            read(11,50) (inc_bil_freq_ge(band,i),i=1,m)
            do i=1,m
               inc_bilkj_freq_ge(band,i)=inc_bil_freq_ge(band,i)
     &              *nsj/rhoCp(i)/1.0D+3 ! K/j
            enddo
         enddo
         close(11)
         call k_extrems(m,Nb,inc_bil_freq_ge,k_min,k_max)
         if (bw.eq.0) then
            file_out='cl_ibfge'
            call make_levels(k_min,k_max,nlevels_bilf,
     &           shift_bilf_levels,1,file_out)
            file_out='rgb_ibilfge'
            call make_rgb_ner(nlevels_bilf,file_out)
         else
            file_out='cl_ibfge_bw'
            call make_levels(k_min,k_max,nlevels_bilf,
     &           shift_bilf_levels,1,file_out)
            file_out='rgb_ibilfge_bw'
            call make_rgb_ner_bw(nlevels_bilf,file_out)
         endif
      endif
c     Cration du fichier de donnes inc_bilan_ge.dat
c     Cration du fichier de contrle 'inc_bilan_ge.ctl'
      st='inc_bilan_ge'
      call write_dat_Nb(m,Nb,inc_bil_freq_ge,sign,st)
      st='inc_bilankj_ge'
      call write_dat_Nb(m,Nb,inc_bilkj_freq_ge,sign,st)
      
      if (recombine.eq.0) then
         file_res=string_res2(1:strlen(string_res2))//
     &        'bilans_freq_ge.txt'
      else
         file_res=string_res2(1:strlen(string_res2))//
     &        'rbilans_freq_ge.txt'
      endif
      open(10,file=file_res,status='old',iostat=ios)
      if (ios.ne.0) then
         close(11)
         write(*,*) 'File "',file_res,'" could not be opened"'
      else
         do band=1,Nb
            read(10,50) (bil_freq_ge2(band,i),i=1,m)
            do i=1,m
               dbil_freq_ge(band,i)=bil_freq_ge2(band,i)-
     &              bil_freq_ge(band,i)
               dbilkj_freq_ge(band,i)=dbil_freq_ge(band,i)
     &              *nsj/rhoCp(i)/1.0D+3 ! K/j
            enddo
         enddo
         call k_extrems(m,Nb,dbil_freq_ge,k_min,k_max)
         if (bw.eq.0) then
            file_out='cl_dbfge'
            call make_levels(k_min,k_max,nlevels_bilf,
     &           shift_bilf_levels,1,file_out)
            file_out='rgb_dbilfge'
            call make_rgb_ner(nlevels_bilf,file_out)
         else
            file_out='cl_dbfge_bw'
            call make_levels(k_min,k_max,nlevels_bilf,
     &           shift_bilf_levels,1,file_out)
            file_out='rgb_dbilfge_bw'
            call make_rgb_ner_bw(nlevels_bilf,file_out)
         endif
         close(10)
      endif
c     Cration du fichier de donnes bilan_ge.dat
c     Cration du fichier de contrle 'bilan_ge.ctl'
      st='dbilan_ge'
      call write_dat_Nb(m,Nb,dbil_freq_ge,sign,st)
      st='dbilankj_ge'
      call write_dat_Nb(m,Nb,dbilkj_freq_ge,sign,st)



c     ................................................................
c     Traitement des bilans frquentiels gaz-gaz et de leurs incertitudes
c     ................................................................
      
      if (recombine.eq.0) then
         file_res=string_res(1:strlen(string_res))//
     &        'bilans_freq_gg.txt'
      else
         file_res=string_res(1:strlen(string_res))//
     &        'rbilans_freq_gg.txt'
      endif
      open(10,file=file_res,status='old',iostat=ios)
      if (ios.ne.0) then
         close(10)
         write(*,*) 'File "',file_res,'" could not be opened"'
      else
         do band=1,Nb
            read(10,50) (bil_freq_gg(band,i),i=1,m)
            do i=1,m
               bilkj_freq_gg(band,i)=bil_freq_gg(band,i)
     &              *nsj/rhoCp(i)/1.0D+3 ! K/j
            enddo
         enddo
         close(10)
         call k_extrems(m,Nb,bil_freq_gg,k_min,k_max)
         if (bw.eq.0) then
            file_out='cl_bfgg'
            call make_levels(k_min,k_max,nlevels_bilf,
     &           shift_bilf_levels,1,file_out)
            file_out='rgb_bilfgg'
            call make_rgb_ner(nlevels_bilf,file_out)
         else
            file_out='cl_bfgg_bw'
            call make_levels(k_min,k_max,nlevels_bilf,
     &           shift_bilf_levels,1,file_out)
            file_out='rgb_bilfgg_bw'
            call make_rgb_ner_bw(nlevels_bilf,file_out)
         endif
      endif
c     Cration du fichier de donnes bilan_gg.dat
c     Cration du fichier de contrle 'bilan_gg.ctl'
      st='bilan_gg'
      call write_dat_Nb(m,Nb,bil_freq_gg,sign,st)
      st='bilankj_gg'
      call write_dat_Nb(m,Nb,bilkj_freq_gg,sign,st)


      if (recombine.eq.0) then
         file_res=string_res(1:strlen(string_res))//
     &        'inc_bilans_freq_gg.txt'
      else
         file_res=string_res(1:strlen(string_res))//
     &        'inc_rbilans_freq_gg.txt'
      endif
      open(11,file=file_res,status='old',iostat=ios)
      if (ios.ne.0) then
         close(11)
         write(*,*) 'File "',file_res,'" could not be opened"'
      else
         do band=1,Nb
            read(11,50) (inc_bil_freq_gg(band,i),i=1,m)
            do i=1,m
               inc_bilkj_freq_gg(band,i)=inc_bil_freq_gg(band,i)
     &              *nsj/rhoCp(i)/1.0D+3 ! K/j
            enddo
         enddo
         close(11)
         call k_extrems(m,Nb,inc_bil_freq_gg,k_min,k_max)
         if (bw.eq.0) then
            file_out='cl_ibfgg'
            call make_levels(k_min,k_max,nlevels_bilf,
     &           shift_bilf_levels,1,file_out)
            file_out='rgb_ibilfgg'
            call make_rgb_ner(nlevels_bilf,file_out)
         else
            file_out='cl_ibfgg_bw'
            call make_levels(k_min,k_max,nlevels_bilf,
     &           shift_bilf_levels,1,file_out)
            file_out='rgb_ibilfgg_bw'
            call make_rgb_ner_bw(nlevels_bilf,file_out)
         endif
      endif
c     Cration du fichier de donnes inc_bilan_gg.dat
c     Cration du fichier de contrle 'inc_bilan_gg.ctl'
      st='inc_bilan_gg'
      call write_dat_Nb(m,Nb,inc_bil_freq_gg,sign,st)
      st='inc_bilankj_gg'
      call write_dat_Nb(m,Nb,inc_bilkj_freq_gg,sign,st)
      
      if (recombine.eq.0) then
         file_res=string_res2(1:strlen(string_res2))//
     &        'bilans_freq_gg.txt'
      else
         file_res=string_res2(1:strlen(string_res2))//
     &        'rbilans_freq_gg.txt'
      endif
      open(10,file=file_res,status='old',iostat=ios)
      if (ios.ne.0) then
         close(10)
         write(*,*) 'File "',file_res,'" could not be opened"'
      else
         do band=1,Nb
            read(10,50) (bil_freq_gg2(band,i),i=1,m)
            do i=1,m
               dbil_freq_gg(band,i)=bil_freq_gg2(band,i)-
     &              bil_freq_gg(band,i)
               dbilkj_freq_gg(band,i)=dbil_freq_gg(band,i)
     &              *nsj/rhoCp(i)/1.0D+3 ! K/j
            enddo
         enddo
         close(10)
         call k_extrems(m,Nb,dbil_freq_gg,k_min,k_max)
         if (bw.eq.0) then
            file_out='cl_dbfgg'
            call make_levels(k_min,k_max,nlevels_bilf,
     &           shift_bilf_levels,1,file_out)
            file_out='rgb_dbilfgg'
            call make_rgb_ner(nlevels_bilf,file_out)
         else
            file_out='cl_dbfgg_bw'
            call make_levels(k_min,k_max,nlevels_bilf,
     &           shift_bilf_levels,1,file_out)
            file_out='rgb_dbilfgg_bw'
            call make_rgb_ner_bw(nlevels_bilf,file_out)
         endif
      endif
c     Cration du fichier de donnes bilan_gg.dat
c     Cration du fichier de contrle 'bilan_gg.ctl'
      st='dbilan_gg'
      call write_dat_Nb(m,Nb,dbil_freq_gg,sign,st)
      st='dbilankj_gg'
      call write_dat_Nb(m,Nb,dbilkj_freq_gg,sign,st)




c     ................................................................
c     Traitement des bilans frquentiels analytiques 
c     ................................................................
      
      if (recombine.eq.0) then
         file_res=string_res(1:strlen(string_res))//
     &        'bil_freq_theo.txt'
      else
         file_res=string_res(1:strlen(string_res))//
     &        'rbil_freq_theo.txt'
      endif
      open(10,file=file_res,status='old',iostat=ios)
      if (ios.ne.0) then
         close(10)
         write(*,*) 'File "',file_res,'" could not be opened"'
      else
         do band=1,Nb
            read(10,50) (bil_freq_tot_theo(band,i),i=1,m) ! mW/m3/cm-1
            do i=1,m
               bilkj_freq_tot_theo(band,i)=bil_freq_tot_theo(band,i)
     &              *nsj/rhoCp(i)/1.0D+3 ! K/j
            enddo
         enddo
         close(10)
         call k_extrems(m,Nb,bil_freq_tot_theo,k_min,k_max)
         if (bw.eq.0) then
            file_out='cl_bfa'
            call make_levels(k_min,k_max,nlevels_bilf,
     &           shift_bilf_levels,1,file_out)
            file_out='rgb_bilfa'
            call make_rgb_ner(nlevels_bilf,file_out)
         else
            file_out='cl_bfa_bw'
            call make_levels(k_min,k_max,nlevels_bilf,
     &           shift_bilf_levels,1,file_out)
            file_out='rgb_bilfa_bw'
            call make_rgb_ner_bw(nlevels_bilf,file_out)
         endif
      endif
c     Cration du fichier de donnes bilan_tot_theo.dat
c     Cration du fichier de contrle 'bilan_tot_theo.ctl'
      st='bilan_tot_theo'
      call write_dat_Nb(m,Nb,bil_freq_tot_theo,sign,st)
      st='bilkj_tot_theo'
      call write_dat_Nb(m,Nb,bilkj_freq_tot_theo,sign,st)

      if (recombine.eq.0) then
         file_res=string_res2(1:strlen(string_res2))//
     &        'bil_freq_theo.txt'
      else
         file_res=string_res2(1:strlen(string_res2))//
     &        'rbil_freq_theo.txt'
      endif
      open(10,file=file_res,status='old',iostat=ios)
      if (ios.ne.0) then
         close(10)
         write(*,*) 'File "',file_res,'" could not be opened"'
      else
         do band=1,Nb
            read(10,50) (bil_freq_tot_theo2(band,i),i=1,m) ! mW/m3/cm-1
            dbil_tot_theo(band)=0.0D+0
            do i=1,m
               dbil_freq_tot_theo(band,i)=bil_freq_tot_theo2(band,i)-
     &              bil_freq_tot_theo(band,i) ! mW/m3/cm-1
               dsbil_freq_tot(band,i)=bil_freq_tot(band,i)-
     &              bil_freq_tot_theo(band,i)
               dbilkj_freq_tot_theo(band,i)=dbil_freq_tot_theo(band,i)
     &              *nsj/rhoCp(i)/1.0D+3 ! K/j
               dsbilkj_freq_tot(band,i)=dsbil_freq_tot(band,i)
     &              *nsj/rhoCp(i)/1.0D+3 ! K/j

               dbil_tot_theo(band)=dbil_tot_theo(band)+
     &              dbil_freq_tot_theo(band,i)*(e(i)-e(i-1))/1.0D+3
     &              *nbw(band)/lbw(band) ! W/m2/m
            enddo ! i
            if (dabs(dbil_tot_theo(band)).lt.1.0D-50) then
               dbil_tot_theo(band)=0.0D+0
            endif
         enddo ! band
         close(10)
         call k_extrems(m,Nb,dbil_freq_tot_theo,k_min,k_max)
         if (bw.eq.0) then
            file_out='cl_dbfa'
            call make_levels(k_min,k_max,nlevels_bilf,
     &           shift_bilf_levels,1,file_out)
            file_out='rgb_dbilfa'
            call make_rgb_ner(nlevels_bilf,file_out)
         else
            file_out='cl_dbfa_bw'
            call make_levels(k_min,k_max,nlevels_bilf,
     &           shift_bilf_levels,1,file_out)
            file_out='rgb_dbilfa_bw'
            call make_rgb_ner_bw(nlevels_bilf,file_out)
         endif
         call k_extrems(m,Nb,dsbil_freq_tot,k_min,k_max)
         if (bw.eq.0) then
            file_out='cl_sdbf'
            call make_levels(k_min,k_max,nlevels_bilf,
     &           shift_bilf_levels,1,file_out)
            file_out='rgb_sdbilf'
            call make_rgb_ner(nlevels_bilf,file_out)
         else
            file_out='cl_sdbf_bw'
            call make_levels(k_min,k_max,nlevels_bilf,
     &           shift_bilf_levels,1,file_out)
            file_out='rgb_sdbilf_bw'
            call make_rgb_ner_bw(nlevels_bilf,file_out)
         endif
      endif
c     Cration du fichier de donnes dbilan_tot_theo.dat
c     Cration du fichier de contrle 'dbilan_tot_theo.ctl'
      st='dbilan_tot_theo'
      call write_dat_Nb(m,Nb,dbil_freq_tot_theo,sign,st)
      st='sdbilan_tot'
      call write_dat_Nb(m,Nb,dsbil_freq_tot,sign,st)
      st='dbilkj_tot_theo'
      call write_dat_Nb(m,Nb,dbilkj_freq_tot_theo,sign,st)
      st='sdbilkj_tot'
      call write_dat_Nb(m,Nb,dsbilkj_freq_tot,sign,st)

      if (recombine.eq.0) then
         file_res=string_res(1:strlen(string_res))//
     &        'bil_freq_gs_theo.txt'
      else
         file_res=string_res(1:strlen(string_res))//
     &        'rbil_freq_gs_theo.txt'
      endif
      open(10,file=file_res,status='old',iostat=ios)
      if (ios.ne.0) then
         close(10)
         write(*,*) 'File "',file_res,'" could not be opened"'
      else
         do band=1,Nb
            read(10,50) (bil_freq_gs_theo(band,i),i=1,m)
            do i=1,m
               bilkj_freq_gs_theo(band,i)=bil_freq_gs_theo(band,i)
     &              *nsj/rhoCp(i)/1.0D+3 ! K/j
            enddo
         enddo
         close(10)
         call k_extrems(m,Nb,bil_freq_gs_theo,k_min,k_max)
         if (bw.eq.0) then
            file_out='cl_bfags'
            call make_levels(k_min,k_max,nlevels_bilf,
     &           shift_bilf_levels,1,file_out)
            file_out='rgb_bilfags'
            call make_rgb_ner(nlevels_bilf,file_out)
         else
            file_out='cl_bfags_bw'
            call make_levels(k_min,k_max,nlevels_bilf,
     &           shift_bilf_levels,1,file_out)
            file_out='rgb_bilfags_bw'
            call make_rgb_ner_bw(nlevels_bilf,file_out)
         endif
      endif
c     Cration du fichier de donnes bilan_gs_theo.dat
c     Cration du fichier de contrle 'bilan_gs_theo.ctl'
      st='bilan_gs_theo'
      call write_dat_Nb(m,Nb,bil_freq_gs_theo,sign,st)
      st='bilkj_gs_theo'
      call write_dat_Nb(m,Nb,bilkj_freq_gs_theo,sign,st)

      if (recombine.eq.0) then
         file_res=string_res2(1:strlen(string_res2))//
     &        'bil_freq_gs_theo.txt'
      else
         file_res=string_res2(1:strlen(string_res2))//
     &        'rbil_freq_gs_theo.txt'
      endif
      open(10,file=file_res,status='old',iostat=ios)
      if (ios.ne.0) then
         close(10)
         write(*,*) 'File "',file_res,'" could not be opened"'
      else
         do band=1,Nb
            read(10,50) (bil_freq_gs_theo2(band,i),i=1,m)
            do i=1,m
               dbil_freq_gs_theo(band,i)=bil_freq_gs_theo2(band,i)-
     &              bil_freq_gs_theo(band,i)
               dsbil_freq_gs(band,i)=bil_freq_gs(band,i)-
     &              bil_freq_gs_theo(band,i)
               dbilkj_freq_gs_theo(band,i)=dbil_freq_gs_theo(band,i)
     &              *nsj/rhoCp(i)/1.0D+3 ! K/j
               dsbilkj_freq_gs(band,i)=dsbil_freq_gs(band,i)
     &              *nsj/rhoCp(i)/1.0D+3 ! K/j

               dbil_gs_theo(band)=dbil_gs_theo(band)+
     &              dbil_freq_gs_theo(band,i)*(e(i)-e(i-1))/1.0D+3
     &              *nbw(band)/lbw(band) ! W/m2/m
            enddo
            if (dabs(dbil_gs_theo(band)).lt.1.0D-50) then
               dbil_gs_theo(band)=0.0D+0
            endif
         enddo
         close(10)
         call k_extrems(m,Nb,dbil_freq_gs_theo,k_min,k_max)
         if (bw.eq.0) then
            file_out='cl_dbfags'
            call make_levels(k_min,k_max,nlevels_bilf,
     &           shift_bilf_levels,1,file_out)
            file_out='rgb_dbilfags'
            call make_rgb_ner(nlevels_bilf,file_out)
         else
            file_out='cl_dbfags_bw'
            call make_levels(k_min,k_max,nlevels_bilf,
     &           shift_bilf_levels,1,file_out)
            file_out='rgb_dbilfags_bw'
            call make_rgb_ner_bw(nlevels_bilf,file_out)
         endif
         call k_extrems(m,Nb,dsbil_freq_gs,k_min,k_max)
         if (bw.eq.0) then
            file_out='cl_sdbfgs'
            call make_levels(k_min,k_max,nlevels_bilf,
     &           shift_bilf_levels,1,file_out)
            file_out='rgb_sdbilfgs'
            call make_rgb_ner(nlevels_bilf,file_out)
         else
            file_out='cl_sdbfgs_bw'
            call make_levels(k_min,k_max,nlevels_bilf,
     &           shift_bilf_levels,1,file_out)
            file_out='rgb_sdbilfgs_bw'
            call make_rgb_ner_bw(nlevels_bilf,file_out)
         endif
      endif
c     Cration du fichier de donnes dbilan_gs_theo.dat
c     Cration du fichier de contrle 'dbilan_gs_theo.ctl'
      st='dbilan_gs_theo'
      call write_dat_Nb(m,Nb,dbil_freq_gs_theo,sign,st)
      st='sdbilan_gs'
      call write_dat_Nb(m,Nb,dsbil_freq_gs,sign,st)
      st='dbilkj_gs_theo'
      call write_dat_Nb(m,Nb,dbilkj_freq_gs_theo,sign,st)
      st='sdbilkj_gs'
      call write_dat_Nb(m,Nb,dsbilkj_freq_gs,sign,st)

      if (recombine.eq.0) then
         file_res=string_res(1:strlen(string_res))//
     &        'bil_freq_ge_theo.txt'
      else
         file_res=string_res(1:strlen(string_res))//
     &        'rbil_freq_ge_theo.txt'
      endif
      open(10,file=file_res,status='old',iostat=ios)
      if (ios.ne.0) then
         close(10)
         write(*,*) 'File "',file_res,'" could not be opened"'
      else
         do band=1,Nb
            read(10,50) (bil_freq_ge_theo(band,i),i=1,m)
            do i=1,m
               bilkj_freq_ge_theo(band,i)=bil_freq_ge_theo(band,i)
     &              *nsj/rhoCp(i)/1.0D+3 ! K/j
            enddo
         enddo
         close(10)
         call k_extrems(m,Nb,bil_freq_ge_theo,k_min,k_max)
         if (bw.eq.0) then
            file_out='cl_bfage'
            call make_levels(k_min,k_max,nlevels_bilf,
     &           shift_bilf_levels,1,file_out)
            file_out='rgb_bilfage'
            call make_rgb_ner(nlevels_bilf,file_out)
         else
            file_out='cl_bfage_bw'
            call make_levels(k_min,k_max,nlevels_bilf,
     &           shift_bilf_levels,1,file_out)
            file_out='rgb_bilfage_bw'
            call make_rgb_ner_bw(nlevels_bilf,file_out)
         endif
      endif
c     Cration du fichier de donnes bilan_ge_theo.dat
c     Cration du fichier de contrle 'bilan_ge_theo.ctl'
      st='bilan_ge_theo'
      call write_dat_Nb(m,Nb,bil_freq_ge_theo,sign,st)
      st='bilkj_ge_theo'
      call write_dat_Nb(m,Nb,bilkj_freq_ge_theo,sign,st)

      if (recombine.eq.0) then
         file_res=string_res2(1:strlen(string_res2))//
     &        'bil_freq_ge_theo.txt'
      else
         file_res=string_res2(1:strlen(string_res2))//
     &        'rbil_freq_ge_theo.txt'
      endif
      open(10,file=file_res,status='old',iostat=ios)
      if (ios.ne.0) then
         close(10)
         write(*,*) 'File "',file_res,'" could not be opened"'
      else
         do band=1,Nb
            read(10,50) (bil_freq_ge_theo2(band,i),i=1,m)
            do i=1,m
               dbil_freq_ge_theo(band,i)=bil_freq_ge_theo2(band,i)-
     &              bil_freq_ge_theo(band,i)
               dsbil_freq_ge(band,i)=bil_freq_ge(band,i)-
     &              bil_freq_ge_theo(band,i)
               dbilkj_freq_ge_theo(band,i)=dbil_freq_ge_theo(band,i)
     &              *nsj/rhoCp(i)/1.0D+3 ! K/j
               dsbilkj_freq_ge(band,i)=dsbil_freq_ge(band,i)
     &              *nsj/rhoCp(i)/1.0D+3 ! K/j

               dbil_ge_theo(band)=dbil_ge_theo(band)+
     &              dbil_freq_ge_theo(band,i)*(e(i)-e(i-1))/1.0D+3
     &              *nbw(band)/lbw(band) ! W/m2/m
            enddo
            if (dabs(dbil_ge_theo(band)).lt.1.0D-50) then
               dbil_ge_theo(band)=0.0D+0
            endif
         enddo
         close(10)
         call k_extrems(m,Nb,dbil_freq_ge_theo,k_min,k_max)
         if (bw.eq.0) then
            file_out='cl_dbfage'
            call make_levels(k_min,k_max,nlevels_bilf,
     &           shift_bilf_levels,1,file_out)
            file_out='rgb_dbilfage'
            call make_rgb_ner(nlevels_bilf,file_out)
         else
            file_out='cl_dbfage_bw'
            call make_levels(k_min,k_max,nlevels_bilf,
     &           shift_bilf_levels,1,file_out)
            file_out='rgb_dbilfage_bw'
            call make_rgb_ner_bw(nlevels_bilf,file_out)
         endif
         call k_extrems(m,Nb,dsbil_freq_ge,k_min,k_max)
         if (bw.eq.0) then
            file_out='cl_sdbfge'
            call make_levels(k_min,k_max,nlevels_bilf,
     &           shift_bilf_levels,1,file_out)
            file_out='rgb_sdbilfge'
            call make_rgb_ner(nlevels_bilf,file_out)
         else
            file_out='cl_sdbfge_bw'
            call make_levels(k_min,k_max,nlevels_bilf,
     &           shift_bilf_levels,1,file_out)
            file_out='rgb_sdbilfge_bw'
            call make_rgb_ner_bw(nlevels_bilf,file_out)
         endif
      endif
c     Cration du fichier de donnes dbilan_ge_theo.dat
c     Cration du fichier de contrle 'dbilan_ge_theo.ctl'
      st='dbilan_ge_theo'
      call write_dat_Nb(m,Nb,dbil_freq_ge_theo,sign,st)
      st='sdbilan_ge'
      call write_dat_Nb(m,Nb,dsbil_freq_ge,sign,st)
      st='dbilkj_ge_theo'
      call write_dat_Nb(m,Nb,dbilkj_freq_ge_theo,sign,st)
      st='sdbilkj_ge'
      call write_dat_Nb(m,Nb,dsbilkj_freq_ge,sign,st)

      if (recombine.eq.0) then
         file_res=string_res(1:strlen(string_res))//
     &        'bil_freq_gg_theo.txt'
      else
         file_res=string_res(1:strlen(string_res))//
     &        'rbil_freq_gg_theo.txt'
      endif
      open(10,file=file_res,status='old',iostat=ios)
      if (ios.ne.0) then
         close(10)
         write(*,*) 'File "',file_res,'" could not be opened"'
      else
         do band=1,Nb
            read(10,50) (bil_freq_gg_theo(band,i),i=1,m)
            do i=1,m
               bilkj_freq_gg_theo(band,i)=bil_freq_gg_theo(band,i)
     &              *nsj/rhoCp(i)/1.0D+3 ! K/j
            enddo
         enddo
         close(10)
         call k_extrems(m,Nb,bil_freq_gg_theo,k_min,k_max)
         if (bw.eq.0) then
            file_out='cl_bfagg'
            call make_levels(k_min,k_max,nlevels_bilf,
     &           shift_bilf_levels,1,file_out)
            file_out='rgb_bilfagg'
            call make_rgb_ner(nlevels_bilf,file_out)
         else
            file_out='cl_bfagg_bw'
            call make_levels(k_min,k_max,nlevels_bilf,
     &           shift_bilf_levels,1,file_out)
            file_out='rgb_bilfagg_bw'
            call make_rgb_ner_bw(nlevels_bilf,file_out)
         endif
      endif
c     Cration du fichier de donnes bilan_gg_theo.dat
c     Cration du fichier de contrle 'bilan_gg_theo.ctl'
      st='bilan_gg_theo'
      call write_dat_Nb(m,Nb,bil_freq_gg_theo,sign,st)
      st='bilkj_gg_theo'
      call write_dat_Nb(m,Nb,bilkj_freq_gg_theo,sign,st)

      if (recombine.eq.0) then
         file_res=string_res2(1:strlen(string_res2))//
     &        'bil_freq_gg_theo.txt'
      else
         file_res=string_res2(1:strlen(string_res2))//
     &        'rbil_freq_gg_theo.txt'
      endif
      open(10,file=file_res,status='old',iostat=ios)
      if (ios.ne.0) then
         close(10)
         write(*,*) 'File "',file_res,'" could not be opened"'
      else
         do band=1,Nb
            read(10,50) (bil_freq_gg_theo2(band,i),i=1,m)
            do i=1,m
               dbil_freq_gg_theo(band,i)=bil_freq_gg_theo2(band,i)-
     &              bil_freq_gg_theo(band,i)
               dsbil_freq_gg(band,i)=bil_freq_gg(band,i)-
     &              bil_freq_gg_theo(band,i)
               dbilkj_freq_gg_theo(band,i)=dbil_freq_gg_theo(band,i)
     &              *nsj/rhoCp(i)/1.0D+3 ! K/j
               dsbilkj_freq_gg(band,i)=dsbil_freq_gg(band,i)
     &              *nsj/rhoCp(i)/1.0D+3 ! K/j

               dbil_gg_theo(band)=dbil_gg_theo(band)+
     &              dbil_freq_gg_theo(band,i)*(e(i)-e(i-1))/1.0D+3
     &              *nbw(band)/lbw(band) ! W/m2/m
            enddo
            if (dabs(dbil_gg_theo(band)).lt.1.0D-50) then
               dbil_gg_theo(band)=0.0D+0
            endif
         enddo
         close(10)
         call k_extrems(m,Nb,dbil_freq_gg_theo,k_min,k_max)
         if (bw.eq.0) then
            file_out='cl_dbfagg'
            call make_levels(k_min,k_max,nlevels_bilf,
     &           shift_bilf_levels,1,file_out)
            file_out='rgb_dbilfagg'
            call make_rgb_ner(nlevels_bilf,file_out)
         else
            file_out='cl_dbfagg_bw'
            call make_levels(k_min,k_max,nlevels_bilf,
     &           shift_bilf_levels,1,file_out)
            file_out='rgb_dbilfagg_bw'
            call make_rgb_ner_bw(nlevels_bilf,file_out)
         endif
         call k_extrems(m,Nb,dsbil_freq_gg,k_min,k_max)
         if (bw.eq.0) then
            file_out='cl_sdbfgg'
            call make_levels(k_min,k_max,nlevels_bilf,
     &           shift_bilf_levels,1,file_out)
            file_out='rgb_sdbilfgg'
            call make_rgb_ner(nlevels_bilf,file_out)
         else
            file_out='cl_sdbfgg_bw'
            call make_levels(k_min,k_max,nlevels_bilf,
     &           shift_bilf_levels,1,file_out)
            file_out='rgb_sdbilfgg_bw'
            call make_rgb_ner_bw(nlevels_bilf,file_out)
         endif
      endif
c     Cration du fichier de donnes bilan_gg_theo.dat
c     Cration du fichier de contrle 'bilan_gg_theo.ctl'
      st='dbilan_gg_theo'
      call write_dat_Nb(m,Nb,dbil_freq_gg_theo,sign,st)
      st='sdbilan_gg'
      call write_dat_Nb(m,Nb,dsbil_freq_gg,sign,st)
      st='dbilkj_gg_theo'
      call write_dat_Nb(m,Nb,dbilkj_freq_gg_theo,sign,st)
      st='sdbilkj_gg'
      call write_dat_Nb(m,Nb,dsbilkj_freq_gg,sign,st)




c     ................................................................
c     Traitement des courbes 2D
c     ................................................................



c     Flux ascendants et descendants intgr sur tout le spectre + thoriques
      file_res=string_res(1:strlen(string_res))//
     &     'flux_at.txt'
      open(22,file=file_res,status='old',iostat=ios)
      if (ios.ne.0) then
         close(22)
         write(*,*) 'File "',file_res,'" could not be opened"'
      else
         do i=0,m
            read(22,*) z_f(i),flux_up(i),inc_flux_up(i)
         enddo
         close(22)
      endif

      file_res=string_res(1:strlen(string_res))//
     &     'flux_dt.txt'
      open(22,file=file_res,status='old',iostat=ios)
      if (ios.ne.0) then
         close(22)
         write(*,*) 'File "',file_res,'" could not be opened"'
      else
         do i=0,m
            read(22,*) z_f(i),flux_dn(i),inc_flux_dn(i)
         enddo
         close(22)
      endif

      file_res=string_res(1:strlen(string_res))//
     &     'flux_theo.txt'
      open(22,file=file_res,status='old',iostat=ios)
      if (ios.ne.0) then
         close(22)
         write(*,*) 'File "',file_res,'" could not be opened"'
      else
         do i=0,2*(m-1)
            read(22,*) z_ft(i),flux_up_theo(i),flux_dn_theo(i)
         enddo
         close(22)
      endif

      file_res=string_res(1:strlen(string_res))//
     &     'Flux_nets_int.txt'
      open(22,file=file_res,status='old',iostat=ios)
      if (ios.ne.0) then
         close(22)
         write(*,*) 'File "',file_res,'" could not be opened"'
      else
         do i=0,m
            read(22,*) raf,raf,raf,flux_net(i),inc_flux_net(i)
         enddo
         close(22)
      endif

      file_res=string_res(1:strlen(string_res))//
     &     'Flux_nets_int_theo.txt'
      open(22,file=file_res,status='old',iostat=ios)
      if (ios.ne.0) then
         close(22)
         write(*,*) 'File "',file_res,'" could not be opened"'
      else
         do i=0,m
            read(22,*) z_ftheo(i),flux_net_theo(i)
         enddo
         close(22)
      endif


      open(10,file='flux_up.txt')
      open(11,file='flux_dn.txt')
      do i=0,m
         write(10,*) z_f(i),sign*flux_up(i),inc_flux_up(i)
         write(11,*) z_f(i),sign*flux_dn(i),inc_flux_dn(i)
      enddo
      close(10)
      close(11)

      open(10,file='flux_up_theo.txt')
      open(11,file='flux_dn_theo.txt')
      do i=0,2*(m-1)
         write(10,*) z_ft(i),sign*flux_up_theo(i)
         write(11,*) z_ft(i),sign*flux_dn_theo(i)
      enddo
      close(10)
      close(11)
      

      open(10,file='flux_nets.txt')
      do i=0,m
         write(10,*) z_f(i)
     &        ,sign*flux_net(i)
     &        ,inc_flux_net(i)
     &        ,sign*flux_net_theo(i)
      enddo
      close(10)

      open(10,file='flux_nets_theo.txt')
      do i=0,m
         write(10,*) z_ftheo(i)
     &        ,sign*flux_net_theo(i)
      enddo
      close(10)


c     Flux au sommet de l'atmosphre et flux nets par bande
      file_res=string_res(1:strlen(string_res))//
     &     'Flux_nets_mono-nu.txt'
      open(22,file=file_res,status='old',iostat=ios)
      if (ios.ne.0) then
         close(22)
         write(*,*) 'File "',file_res,'" could not be opened"'
      else
         read(22,*)
         do band=1,Nb
c     Debug
c            write(*,*) 'band=',band,' /',Nb
c     Debug
            read(22,*) lambda_lo(band),lambda_hi(band)
c     Les flux et incertitudes fnetb_pne et inc_fnetb_pne
c     sont sauvegards en W/m/cm-1
            read(22,50) (fnetb_pne(band,i),i=0,m)
            read(22,50) (inc_fnetb_pne(band,i),i=0,m)
            if (dir_idx.gt.38) then ! format change
               read(22,50) 
               read(22,50) 
            endif

c     Debug
c     write(*,*) band,fnetb_pne(band,0),fnetb_pne(band,1)
c     Debug
            no_lo(band)=1.0D+4/lambda_hi(band)
            no_hi(band)=1.0D+4/lambda_lo(band)
            lambda_c(band)=(lambda_lo(band)+lambda_hi(band))/2.0D+0
            no_c(band)=(no_lo(band)+no_hi(band))/2.0D+0
         enddo
         close(22)
         call k_extrems(m,Nb,fnetb_pne,k_min,k_max)
         if (bw.eq.0) then
            file_out='cl_fnetb'
            call make_levels(k_min,k_max,nlevels_bilf,
     &           shift_bilf_levels,1,file_out)
            file_out='rgb_fnetb'
            call make_rgb_ner(nlevels_bilf,file_out)
         else
            file_out='cl_fnetb_bw'
            call make_levels(k_min,k_max,nlevels_bilf,
     &           shift_bilf_levels,1,file_out)
            file_out='rgb_fnetb_bw'
            call make_rgb_ner_bw(nlevels_bilf,file_out)
         endif
      endif

      file_res=string_res(1:strlen(string_res))//
     &     'Flux_nets_mono-nu_theo.txt'
      open(22,file=file_res,status='old',iostat=ios)
      if (ios.ne.0) then
         close(22)
         write(*,*) 'File "',file_res,'" could not be opened"'
      else
         read(22,*)
         do band=1,Nb
            read(22,*)
            read(22,50) (fnetb_pne_theo(band,i),i=0,m)
            read(22,*)
         enddo                  ! band
         close(22)
         call k_extrems(m,Nb,fnetb_pne_theo,k_min,k_max)
         if (bw.eq.0) then
            file_out='cl_fnetba'
            call make_levels(k_min,k_max,nlevels_bilf,
     &           shift_bilf_levels,1,file_out)
            file_out='rgb_fnetba'
            call make_rgb_ner(nlevels_bilf,file_out)
         else
            file_out='cl_fnetba_bw'
            call make_levels(k_min,k_max,nlevels_bilf,
     &           shift_bilf_levels,1,file_out)
            file_out='rgb_fnetba_bw'
            call make_rgb_ner_bw(nlevels_bilf,file_out)
         endif
      endif

c     Cration du fichier de donnes flux_net_band.dat
c     Cration du fichier de contrle 'flux_net_band.ctl'
      st='flux_netb'
      call write_dat_flux(m,Nb,fnetb_pne,sign,st)

c     Cration du fichier de donnes inc_flux_net_band.dat
c     Cration du fichier de contrle 'inc_flux_net_band.ctl'
      st='inc_flux_netb'
      call write_dat_flux(m,Nb,inc_fnetb_pne,sign,st)

c     Cration du fichier de donnes flux_net_band_theo.dat
c     Cration du fichier de contrle 'flux_net_band_theo.ctl'
      st='flux_netb_theo'
      call write_dat_flux(m,Nb,fnetb_pne_theo,sign,st)

      ntplot=5 ! nombre de courbes de Planck  tracer
      dT=10 ! K
      Tplot(1)=232.0D+0
      do itplot=2,ntplot
         Tplot(itplot)=Tplot(itplot-1)+dT
      enddo ! itplot
      i_test=81 ! pour 0.0 atm
c      i_test=53 ! pour 0.79 atm
c      i_test=47 ! pour 1.72 atm
c      i_test=6 ! pour 68.3 atm
c     Cration du fichier de donnes flux_toa.txt
      open(77,file='./flux_toa.txt')
      open(78,file='./flux_Planck.txt')
      do band=1,Nb
         do itplot=1,ntplot
            B0(itplot)= Planck(cpb,Tplot(itplot),
     &           lambda_lo(band),lambda_hi(band))
         enddo
c     Fichier "flux_toa.txt":
c     col. 1: lambda infrieure de la bande (m)
c     col. 2: nombre d'onde sup. de la bande (cm)
c     col. 3: flux net dans la bande en W/m/m
c     col. 4: incertitude en W/m/m
c     col. 5: flux net dans la bande en mW/m/cm
c     col. 6: incertitude en mW/m/cm
c     col. 7: flux noir en mW/m/cm
         write(77,50) lambda_lo(band)
     &        ,no_hi(band)
     &        ,sign*fnetb_pne(band,i_test)*nbw(band)/lbw(band) ! W/m
     &        ,inc_fnetb_pne(band,i_test)*nbw(band)/lbw(band) ! W/m
     &        ,sign*fnetb_pne(band,i_test) ! W/m/cm
     &        ,inc_fnetb_pne(band,i_test) ! W/m/cm
     &        ,sign*pi*B0(1)*lbw(band)/nbw(band) ! W/m/cm
c     &        ,sign*fnetb_pne(band,i_test)*nbw(band) ! W/m
c     &        ,inc_fnetb_pne(band,i_test)*nbw(band) ! W/m
c     &        ,sign*pi*B0(1)*lbw(band)/nbw(band)*nbw(band) ! W/m
         write(77,50) lambda_hi(band)
     &        ,no_lo(band)
     &        ,sign*fnetb_pne(band,i_test)*nbw(band)/lbw(band) ! W/m
     &        ,inc_fnetb_pne(band,i_test)*nbw(band)/lbw(band) ! W/m
     &        ,sign*fnetb_pne(band,i_test) ! W/m/cm
     &        ,inc_fnetb_pne(band,i_test) ! W/m/cm
     &        ,sign*pi*B0(1)*lbw(band)/nbw(band) ! W/m/cm
c     &        ,sign*fnetb_pne(band,i_test)*nbw(band) ! W/m
c     &        ,inc_fnetb_pne(band,i_test)*nbw(band) ! W/m
c     &        ,sign*pi*B0(1)*lbw(band)/nbw(band)*nbw(band) ! W/m
c     Fichier "flux_Planck.txt":
c     col. 1: nu en cm
c     col. 2: pi*B(Tplot(1)) en mW/m/cm
c     col. 2: pi*B(Tplot(2)) en mW/m/cm
c     etc...
         write(78,50) no_c(band),(sign*pi*B0(itplot)/
     &        nbw(band)*1.0D+3,itplot=1,ntplot)
      enddo ! band
      close(77)
      close(78)


c      open(79,file='./Tb.txt')
c      do band=1,Nb
c         call Tb(lambda_c(band),dabs(fnetb_pne(band,i_test)
c     &        *nbw(band)/lbw(band)),Tblack)
c         write(79,*) lambda_lo(band),no_hi(band),Tblack
c         write(79,*) lambda_hi(band),no_lo(band),Tblack
c      enddo ! band
c      close(79)



c     Bilan radiatif rpertoire 1
      if (recombine.eq.0) then
         file_res=string_res(1:strlen(string_res))//
     &        'Tsource.txt'
         open(22,file=file_res,status='old',iostat=ios)
         if (ios.ne.0) then
            close(22)
            write(*,*) 'File "',file_res,'" could not be opened"'
         else
            do i=1,m
               read(22,*) z(i),raf,raf,raf,raf,psi(i),inc_psi(i)
     &              ,coolr(i),inc_coolr(i)
            enddo
            close(22)
         endif
      else
         file_res=string_res(1:strlen(string_res))//
     &        'rTsource.txt'
         open(22,file=file_res,status='old',iostat=ios)
         if (ios.ne.0) then
            close(22)
            write(*,*) 'File "',file_res,'" could not be opened"'
         else
            do i=1,m
               read(22,*) z(i),raf,raf,raf,raf,psi(i),inc_psi(i)
            enddo
            close(22)
         endif
      endif
c     Calcul des taux de refroidissement
      do i=1,m
c     psi(i) est donn en mW/m
         psiKj(i)=psi(i)*nsj/rhoCp(i)/1.0D+3 ! K/j
         inc_psiKj(i)=inc_psi(i)*nsj/rhoCp(i)/1.0D+3 ! K/j
c     saturation  100K/j pour trac pas trop moche
         if (dabs(psiKj(i)).gt.1.0D+2) then
            psiKj(i)=psiKj(i)/dabs(psiKj(i))*1.0D+2
         endif
      enddo ! i
c     Dcomposition du bilan intgr sur le spectre
      do i=1,m
         psi_gs(i)=tPNEsym(i,0) ! W/m
         inc_psi_gs(i)=inc_tPNEsym(i,0) ! W/m
         psi_gsKj(i)=psi_gs(i)*nsj/rhoCp(i)/(e(i)-e(i-1)) ! K/j
         inc_psi_gsKj(i)=inc_psi_gs(i)*nsj/rhoCp(i)/(e(i)-e(i-1)) ! K/j
c     saturation  100K/j pour trac pas trop moche
         if (dabs(psi_gsKj(i)).gt.1.0D+2) then
            psi_gsKj(i)=psi_gsKj(i)/dabs(psi_gsKj(i))*1.0D+2
         endif
         psi_ge(i)=tPNEsym(i,m+1) ! W/m
         inc_psi_ge(i)=inc_tPNEsym(i,m+1) ! W/m
         psi_geKj(i)=psi_ge(i)*nsj/rhoCp(i)/(e(i)-e(i-1)) ! K/j
         inc_psi_geKj(i)=inc_psi_ge(i)*nsj/rhoCp(i)/(e(i)-e(i-1)) ! K/j
c     saturation  100K/j pour trac pas trop moche
         if (dabs(psi_geKj(i)).gt.1.0D+2) then
            psi_geKj(i)=psi_geKj(i)/dabs(psi_geKj(i))*1.0D+2
         endif
         psi_gg(i)=0.0D+0
         inc_psi_gg(i)=0.0D+0
         do j=1,m
            psi_gg(i)=psi_gg(i)+tPNEsym(i,j) ! W/m
            inc_psi_gg(i)=inc_psi_gg(i)+inc_tPNEsym(i,j) ! W/m
         enddo                  ! j
         psi_ggKj(i)=psi_gg(i)*nsj/rhoCp(i)/(e(i)-e(i-1)) ! K/j
         inc_psi_ggKj(i)=inc_psi_gg(i)*nsj/rhoCp(i)/(e(i)-e(i-1)) ! K/j
c     saturation  100K/j pour trac pas trop moche
         if (dabs(psi_ggKj(i)).gt.1.0D+2) then
            psi_ggKj(i)=psi_ggKj(i)/dabs(psi_ggKj(i))*1.0D+2
         endif
      enddo                     ! i

c     Si le fichier n'a pas pu tre ouvert, alors il y a un pb: le tableau
c     des altitudes "z" n'a pas pu tre lu. Il faut tenter de le lire
c     dans un autre fichier.
      if (ios.ne.0) then
         zhbr=0
      else
         zhbr=1
      endif

c     Bilan radiatif rpertoire 2
      if (recombine.eq.0) then
         file_res=string_res2(1:strlen(string_res2))//
     &        'Tsource.txt'
         open(22,file=file_res,status='old',iostat=ios)
         if (ios.ne.0) then
            close(22)
            write(*,*) 'File "',file_res,'" could not be opened"'
         else
            do i=1,m
               read(22,*) raf,raf,raf,raf,raf,psi2(i),inc_psi2(i)
c     &              ,raf,raf
            enddo
            close(22)
         endif
      else
         file_res=string_res2(1:strlen(string_res2))//
     &        'rTsource.txt'
         open(22,file=file_res,status='old',iostat=ios)
         if (ios.ne.0) then
            close(22)
            write(*,*) 'File "',file_res,'" could not be opened"'
         else
            do i=1,m
               read(22,*) raf,raf,raf,raf,raf,psi2(i),inc_psi2(i)
            enddo
            close(22)
         endif
      endif
c     Calcul des taux de refroidissement
      do i=1,m
         psiKj2(i)=psi2(i)*nsj/rhoCp(i)/1.0D+3 ! K/j
         inc_psiKj2(i)=inc_psi2(i)*nsj/rhoCp(i)/1.0D+3 ! K/j
c     saturation  100K/j pour trac pas trop moche
         if (dabs(psiKj2(i)).gt.1.0D+2) then
            psiKj2(i)=psiKj2(i)/dabs(psiKj2(i))*1.0D+2
         endif
      enddo ! i
c     Dcomposition du bilan intgr sur le spectre
      do i=1,m
         psi_gs2(i)=tPNEsym2(i,0) ! W/m
         inc_psi_gs2(i)=inc_tPNEsym2(i,0) ! W/m
         psi_gsKj2(i)=psi_gs2(i)*nsj/rhoCp(i)/(e(i)-e(i-1)) ! K/j
         inc_psi_gsKj2(i)=inc_psi_gs2(i)*nsj/rhoCp(i)/(e(i)-e(i-1)) ! K/j
c     saturation  100K/j pour trac pas trop moche
         if (dabs(psi_gsKj2(i)).gt.1.0D+2) then
            psi_gsKj2(i)=psi_gsKj2(i)/dabs(psi_gsKj2(i))*1.0D+2
         endif
         psi_ge2(i)=tPNEsym2(i,m+1) ! W/m
         inc_psi_ge2(i)=inc_tPNEsym2(i,m+1) ! W/m
         psi_geKj2(i)=psi_ge2(i)*nsj/rhoCp(i)/(e(i)-e(i-1)) ! K/j
         inc_psi_geKj2(i)=inc_psi_ge2(i)*nsj/rhoCp(i)/(e(i)-e(i-1)) ! K/j
c     saturation  100K/j pour trac pas trop moche
         if (dabs(psi_geKj2(i)).gt.1.0D+2) then
            psi_geKj2(i)=psi_geKj2(i)/dabs(psi_geKj2(i))*1.0D+2
         endif
         psi_gg2(i)=0.0D+0
         inc_psi_gg2(i)=0.0D+0
         do j=1,m
            psi_gg2(i)=psi_gg2(i)+tPNEsym2(i,j) ! W/m
            inc_psi_gg2(i)=inc_psi_gg2(i)+inc_tPNEsym2(i,j) ! W/m
         enddo                  ! j
         psi_ggKj2(i)=psi_gg2(i)*nsj/rhoCp(i)/(e(i)-e(i-1)) ! K/j
         inc_psi_ggKj2(i)=inc_psi_gg2(i)*nsj/rhoCp(i)/(e(i)-e(i-1)) ! K/j
c     saturation  100K/j pour trac pas trop moche
         if (dabs(psi_ggKj2(i)).gt.1.0D+2) then
            psi_ggKj2(i)=psi_ggKj2(i)/dabs(psi_ggKj2(i))*1.0D+2
         endif
      enddo                     ! i

c     Diffrences sur les bilans et leur dcomposition
      do i=1,m
         dpsi(i)=psi2(i)-psi(i) ! mW/m
         inc_dpsi(i)=inc_psi(i)+inc_psi2(i) ! mW/m
         dpsi_gs(i)=psi_gs2(i)-psi_gs(i) ! W/m
         inc_dpsi_gs(i)=inc_psi_gs2(i)+inc_psi_gs(i) ! W/m
         dpsi_ge(i)=psi_ge2(i)-psi_ge(i) ! W/m
         inc_dpsi_ge(i)=inc_psi_ge2(i)+inc_psi_ge(i) ! W/m
         dpsi_gg(i)=psi_gg2(i)-psi_gg(i) ! W/m
         inc_dpsi_gg(i)=inc_psi_gg2(i)+inc_psi_gg(i) ! W/m
         dpsiKj(i)=psiKj2(i)-psiKj(i) ! K/day
         inc_dpsiKj(i)=inc_psiKj2(i)+inc_psiKj(i) ! K/day
         dpsi_gsKj(i)=psi_gsKj2(i)-psi_gsKj(i) ! K/day
         inc_dpsi_gsKj(i)=inc_psi_gsKj2(i)+inc_psi_gsKj(i) ! K/day
         dpsi_geKj(i)=psi_geKj2(i)-psi_geKj(i) ! K/day
         inc_dpsi_geKj(i)=inc_psi_geKj2(i)+inc_psi_geKj(i) ! K/day
         dpsi_ggKj(i)=psi_ggKj2(i)-psi_ggKj(i) ! K/day
         inc_dpsi_ggKj(i)=inc_psi_ggKj2(i)+inc_psi_ggKj(i) ! K/day
      enddo


c     Bilan radiatif analytique, et diffrence
      if (recombine.eq.0) then
         file_res=string_res(1:strlen(string_res))//
     &        'bil_theo.txt'
      else
         file_res=string_res(1:strlen(string_res))//
     &        'rbil_theo.txt'
      endif
      open(23,file=file_res,status='old',iostat=ios)
      if (ios.ne.0) then
         close(23)
         write(*,*) 'File "',file_res,'" could not be opened"'
      else
         do i=1,m
            read(23,*) z2(i),raf,raf,psi_theo(i) ! mW/m
            psiKj_theo(i)=psi_theo(i)*nsj/rhoCp(i)/1.0D+3 ! K/j
c     saturation  100K/j pour trac pas trop moche
            if (dabs(psiKj_theo(i)).gt.1.0D+2) then
               psiKj_theo(i)=psiKj_theo(i)/dabs(psiKj_theo(i))*1.0D+2
            endif
         enddo
         close(23)
      endif
c     Dcomposition des bilans analytiques
      do i=1,m
         psi_gs_theo(i)=tPNEtheo(i,0) ! W/m
         psiKj_gs_theo(i)=psi_gs_theo(i)*nsj/rhoCp(i)/(e(i)-e(i-1)) ! K/j
c     saturation  100K/j pour trac pas trop moche
         if (dabs(psiKj_gs_theo(i)).gt.1.0D+2) then
            psiKj_gs_theo(i)=psiKj_gs_theo(i)/dabs(psiKj_gs_theo(i))
     &           *1.0D+2
         endif
         psi_ge_theo(i)=tPNEtheo(i,m+1) ! W/m
         psiKj_ge_theo(i)=psi_ge_theo(i)*nsj/rhoCp(i)/(e(i)-e(i-1)) ! K/j
c     saturation  100K/j pour trac pas trop moche
         if (dabs(psiKj_ge_theo(i)).gt.1.0D+2) then
            psiKj_ge_theo(i)=psiKj_ge_theo(i)/dabs(psiKj_ge_theo(i))
     &           *1.0D+2
         endif
         psi_gg_theo(i)=0.0D+0
         do j=1,m
            psi_gg_theo(i)=psi_gg_theo(i)+tPNEtheo(i,j) ! W/m
         enddo                  ! j
         psiKj_gg_theo(i)=psi_gg_theo(i)*nsj/rhoCp(i)/(e(i)-e(i-1)) ! K/j
c     saturation  100K/j pour trac pas trop moche
         if (dabs(psiKj_gg_theo(i)).gt.1.0D+2) then
            psiKj_gg_theo(i)=psiKj_gg_theo(i)/dabs(psiKj_gg_theo(i))
     &           *1.0D+2
         endif
      enddo                     ! i


      if (ios.ne.0) then
         z2hbr=0
      else
         z2hbr=1
      endif
c     Dans le cas o le tableau "z" n'a pas pu tre lu dans 'Tsource.txt', mais
c     o le tableau "z2" a pu tre lu dans 'bil_theo.txt', alors on affecte
c     les valeurs de "z2"  "z".
      if ((zhbr.eq.0).and.(z2hbr.eq.1)) then
         do i=1,m
            z(i)=z2(i)
         enddo
c     Si jamais aucun des deux fichiers n'a pu tre ouvert, il faut
c     afficher un message d'erreur.
      else if ((zhbr.eq.0).and.(z2hbr.eq.0)) then
         write(*,*) 'Error: altitude array could not be read'
         write(*,*) 'Budget plots may be incorrect'
      endif
         

      if (recombine.eq.0) then
         file_res=string_res2(1:strlen(string_res2))//
     &        'bil_theo.txt'
      else
         file_res=string_res2(1:strlen(string_res2))//
     &        'rbil_theo.txt'
      endif
      open(24,file=file_res,status='old',iostat=ios)
      if (ios.ne.0) then
         close(24)
         write(*,*) 'File "',file_res,'" could not be opened"'
      else
         do i=1,m
            read(24,*) raf,raf,raf,psi_theo2(i) ! mW/m
            psiKj_theo2(i)=psi_theo2(i)*nsj/rhoCp(i)/1.0D+3 ! K/j
c     saturation  100K/j pour trac pas trop moche
            if (dabs(psiKj_theo2(i)).gt.1.0D+2) then
               psiKj_theo2(i)=psiKj_theo2(i)/dabs(psiKj_theo2(i))
     &              *1.0D+2
            endif
            dpsi_theo(i)=psi_theo2(i)-psi_theo(i) ! mW/m
            dpsiKj_theo(i)=psiKj_theo2(i)-psiKj_theo(i)
         enddo
         close(24)
      endif
c     Dcomposition des bilans analytiques
      do i=1,m
         psi_gs_theo2(i)=tPNEtheo2(i,0) ! W/m
         psiKj_gs_theo2(i)=psi_gs_theo2(i)*nsj/rhoCp(i)/(e(i)-e(i-1)) ! K/j
c     saturation  100K/j pour trac pas trop moche
         if (dabs(psiKj_gs_theo2(i)).gt.1.0D+2) then
            psiKj_gs_theo2(i)=psiKj_gs_theo2(i)/dabs(psiKj_gs_theo2(i))
     &           *1.0D+2
         endif
         psi_ge_theo2(i)=tPNEtheo2(i,m+1) ! W/m
         psiKj_ge_theo2(i)=psi_ge_theo2(i)*nsj/rhoCp(i)/(e(i)-e(i-1)) ! K/j
c     saturation  100K/j pour trac pas trop moche
         if (dabs(psiKj_ge_theo2(i)).gt.1.0D+2) then
            psiKj_ge_theo2(i)=psiKj_ge_theo2(i)/dabs(psiKj_ge_theo2(i))
     &           *1.0D+2
         endif
         psi_gg_theo2(i)=0.0D+0
         do j=1,m
            psi_gg_theo2(i)=psi_gg_theo2(i)+tPNEtheo2(i,j) ! W/m
         enddo                  ! j
         psiKj_gg_theo2(i)=psi_gg_theo2(i)*nsj/rhoCp(i)/(e(i)-e(i-1)) ! K/j
c     saturation  100K/j pour trac pas trop moche
         if (dabs(psiKj_gg_theo2(i)).gt.1.0D+2) then
            psiKj_gg_theo2(i)=psiKj_gg_theo2(i)/dabs(psiKj_gg_theo2(i))
     &           *1.0D+2
         endif
      enddo                     ! i
c     Diffrences
      do i=1,m
         dpsi_gs_theo(i)=psi_gs_theo2(i)-psi_gs_theo(i) ! W/m
         dpsi_ge_theo(i)=psi_ge_theo2(i)-psi_ge_theo(i) ! W/m
         dpsi_gg_theo(i)=psi_gg_theo2(i)-psi_gg_theo(i) ! W/m
         dpsiKj_gs_theo(i)=psiKj_gs_theo2(i)-psiKj_gs_theo(i) ! K/day
         dpsiKj_ge_theo(i)=psiKj_ge_theo2(i)-psiKj_ge_theo(i) ! K/day
         dpsiKj_gg_theo(i)=psiKj_gg_theo2(i)-psiKj_gg_theo(i) ! K/day
      enddo

c     Cration du fichier de donnes budget.txt
      open(77,file='./budget.txt')
      do i=1,m
c     colonnes 1,2,3: budget (mW/m en fonction de z)
c     colonnes 4,5,6: budget (K/day en fonction de z)
c     colonnes 7,8,9: budget (W/m en fonction de z)
c     colonnes 10,11,12: budget gaz-sol (mW/m en fonction de z)
c     colonnes 13,14,15: budget gaz-sol (W/m en fonction de z)
c     colonnes 16,17,18: budget gaz-espace (mW/m en fonction de z)
c     colonnes 19,20,21: budget gaz-espace (W/m en fonction de z)
c     colonnes 22,23,24: budget gaz-gaz (mW/m en fonction de z)
c     colonnes 25,26,27: budget gaz-gaz (W/m en fonction de z)
c     colonnes 28,29,30: budget gaz-sol (K/day en fonction de z)
c     colonnes 31,32,33: budget gaz-espace (K/day en fonction de z)
c     colonnes 34,35,36: budget gaz-gaz (K/day en fonction de z)
         write(77,50) sign*psi(i),z(i),inc_psi(i),
     &        sign*psiKj(i),z(i),inc_psiKj(i),
     &        sign*psi(i)*(e(i)-e(i-1))/1.0D+3,z(i),
     &        inc_psi(i)*(e(i)-e(i-1))/1.0D+3,
     &        sign*psi_gs(i)*1.0D+3/(e(i)-e(i-1)),z(i),
     &        inc_psi_gs(i)*1.0D+3/(e(i)-e(i-1)),
     &        sign*psi_gs(i),z(i),inc_psi_gs(i),
     &        sign*psi_ge(i)*1.0D+3/(e(i)-e(i-1)),z(i),
     &        inc_psi_ge(i)*1.0D+3/(e(i)-e(i-1)),
     &        sign*psi_ge(i),z(i),inc_psi_ge(i),
     &        sign*psi_gg(i)*1.0D+3/(e(i)-e(i-1)),z(i),
     &        inc_psi_gg(i)*1.0D+3/(e(i)-e(i-1)),
     &        sign*psi_gg(i),z(i),inc_psi_gg(i),
     &        sign*psi_gsKj(i),z(i),inc_psi_gsKj(i),
     &        sign*psi_geKj(i),z(i),inc_psi_geKj(i),
     &        sign*psi_ggKj(i),z(i),inc_psi_ggKj(i)
      enddo
      close(77)

c     Cration du fichier de donnes dbudget.txt
      open(77,file='./dbudget.txt')
c     colonnes 1,2,3: diffrence sur budget total (mW/m)
c     colonnes 4,5,6: diffrence sur budget total (W/m)
c     colonnes 7,8,9: diffrence sur budget gaz-sol (mW/m)
c     colonnes 10,11,12: diffrence sur budget gaz-sol (W/m)
c     colonnes 13,14,15: diffrence sur budget gaz-espace (mW/m)
c     colonnes 16,17,18: diffrence sur budget gaz-espace (W/m)
c     colonnes 19,20,21: diffrence sur budget gaz-gaz (mW/m)
c     colonnes 22,23,24: diffrence sur budget gaz-gaz (W/m)
c     colonnes 25,26,27: diffrence sur budget total (K/day)
c     colonnes 28,29,30: diffrence sur budget gaz-sol (K/day)
c     colonnes 31,32,33: diffrence sur budget gaz-espace (K/day)
c     colonnes 34,35,36: diffrence sur budget gaz-gaz (K/day)
      do i=1,m
         write(77,50) sign*dpsi(i),z(i),inc_dpsi(i),
     &        sign*dpsi(i)*(e(i)-e(i-1))/1.0D+3,z(i),
     &        inc_dpsi(i)*(e(i)-e(i-1))/1.0D+3,
     &        sign*dpsi_gs(i)*1.0D+3/(e(i)-e(i-1)),z(i),
     &        inc_dpsi_gs(i)*1.0D+3/(e(i)-e(i-1)),
     &        sign*dpsi_gs(i),z(i),inc_dpsi_gs(i),
     &        sign*dpsi_ge(i)*1.0D+3/(e(i)-e(i-1)),z(i),
     &        inc_dpsi_ge(i)*1.0D+3/(e(i)-e(i-1)),
     &        sign*dpsi_ge(i),z(i),inc_dpsi_ge(i),
     &        sign*dpsi_gg(i)*1.0D+3/(e(i)-e(i-1)),z(i),
     &        inc_dpsi_gg(i)*1.0D+3/(e(i)-e(i-1)),
     &        sign*dpsi_gg(i),z(i),inc_dpsi_gg(i),
     &        sign*dpsiKj(i),z(i),inc_dpsiKj(i),
     &        sign*dpsi_gsKj(i),z(i),inc_dpsi_gsKj(i),
     &        sign*dpsi_geKj(i),z(i),inc_dpsi_geKj(i),
     &        sign*dpsi_ggKj(i),z(i),inc_dpsi_ggKj(i)
      enddo
      close(77)

c     Cration du fichier de donnes budget_theo.txt
      open(77,file='./budget_theo.txt')
      do i=1,m
c     colonnes 1,2: budget (mW/m en fonction de z)
c     colonnes 3,4: budget (K/day en fonction de z)
c     colonnes 5,6: budget (W/m en fonction de z)
c     colonnes 7,8: budget gaz-sol (mW/m en fonction de z)
c     colonnes 9,10: budget gaz-sol (W/m en fonction de z)
c     colonnes 11,12: budget gaz-espace (mW/m en fonction de z)
c     colonnes 13,14: budget gaz-espace (W/m en fonction de z)
c     colonnes 15,16: budget gaz-gaz (mW/m en fonction de z)
c     colonnes 17,18: budget gaz-gaz (W/m en fonction de z)
c     colonnes 19,20: budget gaz-sol (K/day en fonction de z)
c     colonnes 21,22: budget gaz-espace (K/day en fonction de z)
c     colonnes 23,24: budget gaz-gaz (K/day en fonction de z)
         write(77,50) sign*psi_theo(i),z(i),
     &        sign*psiKj_theo(i),z(i),
     &        sign*psi_theo(i)*(e(i)-e(i-1))*1.0D-3,z(i),
     &        sign*psi_gs_theo(i)*1.0D+3/(e(i)-e(i-1)),z(i),
     &        sign*psi_gs_theo(i),z(i),
     &        sign*psi_ge_theo(i)*1.0D+3/(e(i)-e(i-1)),z(i),
     &        sign*psi_ge_theo(i),z(i),
     &        sign*psi_gg_theo(i)*1.0D+3/(e(i)-e(i-1)),z(i),
     &        sign*psi_gg_theo(i),z(i),
     &        sign*psiKj_gs_theo(i),z(i),
     &        sign*psiKj_ge_theo(i),z(i),
     &        sign*psiKj_gg_theo(i),z(i)
      enddo
      close(77)

c     Cration du fichier de donnes dbudget_theo.txt
      open(77,file='./dbudget_theo.txt')
      do i=1,m
c     colonne 1: z
c     colonne 2: diffrence de budget en mW/m
c     colonne 3: diffrence de budget en K/day
c     colonne 4: diffrence de budget en W/m
c     colonne 5: diffrence de budget gaz-sol en mW/m
c     colonne 6: diffrence de budget gaz-sol en W/m
c     colonne 7: diffrence de budget gaz-espace en mW/m
c     colonne 8: diffrence de budget gaz-espace en W/m
c     colonne 9: diffrence de budget gaz-gaz en mW/m
c     colonne 10: diffrence de budget gaz-gaz en W/m
c     colonne 11: diffrence de budget gaz-sol en K/day
c     colonne 12: diffrence de budget gaz-espace en K/day
c     colonne 13: diffrence de budget gaz-gaz en K/day
         write(77,50) z(i)
     &        ,sign*dpsi_theo(i)
     &        ,sign*dpsiKj_theo(i),
     &        sign*dpsi_theo(i)*(e(i)-e(i-1))*1.0D-3,
     &        sign*dpsi_gs_theo(i)*1.0D+3/(e(i)-e(i-1)),
     &        sign*dpsi_gs_theo(i),
     &        sign*dpsi_ge_theo(i)*1.0D+3/(e(i)-e(i-1)),
     &        sign*dpsi_ge_theo(i),
     &        sign*dpsi_gg_theo(i)*1.0D+3/(e(i)-e(i-1)),
     &        sign*dpsi_gg_theo(i),
     &        sign*dpsiKj_gs_theo(i),
     &        sign*dpsiKj_ge_theo(i),
     &        sign*dpsiKj_gg_theo(i)
      enddo
      close(77)

c     Bilan radiatif de l'atmosphre (analytique) par bande troite
      open(23,file='./bilan_atm.txt')
      do band=1,Nb
c     colonne 1: numro de bande troite
c     colonne 2: longueur d'onde (m)
c     colonne 3: diffrence de bilan radiatif total de l'atmosphre (W/m2/m)
c     colonne 4: diffrence de bilan bilan radiatif gaz-sol de l'atmosphre (W/m2/m)
c     colonne 5: diffrence de bilan bilan radiatif gaz-espace de l'atmosphre (W/m2/m)
c     colonne 6: diffrence de bilan bilan radiatif gaz-gaz de l'atmosphre (W/m2/m)
c     colonne 7: diffrence de bilan radiatif total de l'atmosphre (W/m2/cm-1)
c     colonne 8: diffrence de bilan bilan radiatif gaz-sol de l'atmosphre (W/m2/cm-1)
c     colonne 9: diffrence de bilan bilan radiatif gaz-espace de l'atmosphre (W/m2/cm-1)
c     colonne 10: diffrence de bilan bilan radiatif gaz-gaz de l'atmosphre (W/m2/cm-1)
         write(23,41) band,lambda_lo(band),
     &        sign*dbil_tot_theo(band),
     &        sign*dbil_gs_theo(band),
     &        sign*dbil_ge_theo(band),
     &        sign*dbil_gg_theo(band),
     &        sign*dbil_tot_theo(band)*lbw(band)/nbw(band),
     &        sign*dbil_gs_theo(band)*lbw(band)/nbw(band),
     &        sign*dbil_ge_theo(band)*lbw(band)/nbw(band),
     &        sign*dbil_gg_theo(band)*lbw(band)/nbw(band)
         write(23,41) band,lambda_hi(band),
     &        sign*dbil_tot_theo(band),
     &        sign*dbil_gs_theo(band),
     &        sign*dbil_ge_theo(band),
     &        sign*dbil_gg_theo(band),
     &        sign*dbil_tot_theo(band)*lbw(band)/nbw(band),
     &        sign*dbil_gs_theo(band)*lbw(band)/nbw(band),
     &        sign*dbil_ge_theo(band)*lbw(band)/nbw(band),
     &        sign*dbil_gg_theo(band)*lbw(band)/nbw(band)
      enddo
      close(23)

c     Cration du fichier de donnes cooling-rate.txt
      open(77,file='./cooling-rate.txt')
      do i=1,m
         write(77,50) sign*coolr(i),z(i),inc_coolr(i)
      enddo
      close(77)

 5421 continue

      end
