      subroutine write_dat_Nb(m,Nb,tab,sign,st)
      implicit none
      include '../includes/param.inc'
      include '../includes/max.inc'
      integer m,Nb,stl,stl1,stl2,i,j,band,irec
      integer strlen,sign
      double precision tab(1:Nbmx,1:Nmax)
      character*100 st,st1,st2,path,file_in
      real*4 tmp

      stl=strlen(st)
      st1=st(1:stl)//'.dat'
      stl1=strlen(st1)
      st2=st(1:stl)//'.ctl'
      stl2=strlen(st2)

      open(10,file='./tmp_dir')
      read(10,'(a)') path
      close(10)
      call add_slash_if_absent(path)

      file_in=path(1:strlen(path))//st1(1:strlen(st1))
      open(77,file=file_in(1:strlen(file_in))
     &     ,form='unformatted'
     &     ,access='direct'
     &     ,recl=4)
      irec=0
      do i=1,m
         do band=1,Nb
            irec=irec+1
            tmp=real(sign*tab(band,i))
            write(77,REC=irec) tmp
         enddo
      enddo
      close(77)

      file_in=path(1:strlen(path))//st2(1:strlen(st2))
      open(10,file=file_in(1:strlen(file_in)))
      write(10,'(a)')'DSET  ^'//st(1:stl)//'.dat'
      write(10,'(a)')'UNDEF                1.E+30'
      write(10,'(a)')'FORMAT'
      write(10,'(a)')'TITLE              Echanges'
      write(10,'(a,i5,a)')'XDEF    ',Nb,'         LINEAR 1 1'
      write(10,'(a)')'YDEF    1            LINEAR 0 1'
      write(10,'(a,i5,a)')'ZDEF    ',m,'          LINEAR 1 1'
      write(10,'(a)')'TDEF    1            LINEAR 02JAN1987 1HR'
      write(10,'(a)')'VARS    1'
      write(10,'(a,i5,a)')
     &     st(1:stl)//'           ',m,' 99 echanges entre couches'
      write(10,'(a)')'ENDVARS'
      close(10)

      return
      end
