c     sensitivities...
      subroutine check_sizes(Nb,Nq,nspecies)
      implicit none
      include 'max.inc'
      include 'data.inc'
      include 'options.inc'

      integer Nb,Nq,Nk,nspecies,nlay
      double precision sdksidT,sdksidx,sdnerdx
      double precision tsdksidT,tsdksidx,tsdnerdx
      parameter(sdksidT=632.0D+0*1024D+0/83/1088) ! kb/k/layer
      parameter(sdksidx=335.0D+0*1024D+0/83/1088) ! kb/k/layer
      parameter(sdnerdx=1.1D+0*1024.0D+0*1024D+0/83/1088) ! kb/k/layer

      Nk=Nb*Nq
      nlay=m+2
      
      tsdksidT=sdksidT*nlay*Nk/1024.0D+0 ! Mb
      tsdksidx=sdksidx*nlay*Nk/1024.0D+0 ! Mb
      tsdnerdx=sdnerdx*nlay*Nk/1024.0D+0 ! Mb

      if ((calc_dNERdTp.eq.1).and.(s_dksidT.eq.1)) then
         call screen(1501,0,0,tsdksidT,0.0D+0)
      endif
      if ((calc_dNERdx.eq.1).and.(s_dksidx.eq.1)) then
         call screen(1502,0,0,tsdksidx,0.0D+0)
      endif
      if ((calc_dNERdx.eq.1).and.(s_dNERdx.eq.1)) then
         call screen(1503,0,0,tsdnerdx,0.0D+0)
      endif
      
      return
      end
c     ...sensitivities
