c     Copyright (C) 2000-2008
c     Universite Paul Sabatier, Toulouse, France

c     This program is free software; you can redistribute it and/or modify
c     it under the terms of the GNU General Public License as published by
c     the Free Software Foundation; either version 2, or (at your option)
c     any later version.

c     This program is distributed in the hope that it will be useful,
c     but WITHOUT ANY WARRANTY; without even the implied warranty of
c     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c     GNU General Public License for more details.

c     You should have received a copy of the GNU General Public License
c     along with this program; if not, write to the Free Software
c     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
c     USA.
c
      subroutine find_tab(m2,e2,i_start,i_end)
      implicit none
      include 'max.inc'
      include 'data.inc'
      include 'param.inc'
c     Purpose: to create 'i_start' and 'i_end' arrays.
c     + 'i_start(i)' is the index of the layer (of arrray 'e')
c     whithin which the lower interface of layer 'i' (of array 'e2')
c     is located.
c     + 'i_end(i)' is the index of the layer (of arrray 'e')
c     whithin which the upper interface of layer 'i' (of array 'e2')
c     is located.

      integer m2,i,i2,out
      integer i_start(1:Nmax)
      integer i_end(1:Nmax)
      double precision e2(0:Nmax)

      do i2=1,m2
c     identification des mailles "anciennes" sur lesquelles s'tend
c     la maille i2 "nouvelle"
         call find_e_i1(e2(i2-1),i_start(i2),out)
c     Debug
c         if (out.ne.0) then
c            write(*,*) 'out=',out
c            write(*,*) 'e2(',i2-1,')=',e2(i2-1)
c         endif
c     Debug
         if (out.eq.-1) then
            i_start(i2)=1
         else if (out.eq.1) then
            i_start(i2)=m
         endif
         call find_e_i1(e2(i2),i_end(i2),out)
c     Debug
c         if (out.ne.0) then
c            write(*,*) 'out=',out
c            write(*,*) 'e2(',i2,')=',e2(i2)
c         endif
c     Debug
         if (out.eq.-1) then
            i_end(i2)=1
         else if (out.eq.1) then
            i_end(i2)=m
         endif
c     Debug
c         write(*,*) i2,i_start(i2),i_end(i2)
c     Debug
      enddo ! sur i2

      return
      end
