       integer DiffMax,Nmax,Pmax,Kmax,Nbmx,Nqmx,Nsmx,PhMax,Na
       integer Nsec_mx
       double precision kmin

c -----------------------------------------------------------------------------
c Dclaration de DiffMax, la taille du tableau RAY. Par dfaut, sa valeur est
c de 10000, mais si le milieu est trs diffusant, cette valeur peut se rvler
c insuffisante, auquel cas le programme plante en gnrant un fichier
c core --->> il suffit d'augmenter la valeur de DiffMax
c -----------------------------------------------------------------------------

      	parameter(DiffMax=10000)

c -----------------------------------------------------------------------------
c Dclaration de Nmax, le nombre de mailles de gaz maximal
c -----------------------------------------------------------------------------

	parameter(Nmax=100)

c -----------------------------------------------------------------------------
c Dclaration de Pmax, la taille des tableaux temporaires d'changes
c -----------------------------------------------------------------------------

	parameter(Pmax=20000)

c -----------------------------------------------------------------------------
c Dclaration de Nbmx, le nombre maximal de bandes troites
c -----------------------------------------------------------------------------

	parameter(Nbmx=70)

c -----------------------------------------------------------------------------
c Dclaration de Nqmx, le nombre maximal de points de quadrature
c -----------------------------------------------------------------------------

	parameter(Nqmx=16)

c -----------------------------------------------------------------------------
c Dclaration de Nsec_mx, le nombre maximal de secteurs angulaires (sur pi)
c -----------------------------------------------------------------------------

	parameter(Nsec_mx=100)


c -----------------------------------------------------------------------------
c Dclaration de Nsmx, le nombre maximal d'espces pour calculs de sensibilits
c -----------------------------------------------------------------------------

	parameter(Nsmx=10)

c -----------------------------------------------------------------------------
c Dclaration de Kmax, le nombre maximal de gaz gris : Nbmx*Nqmx
c -----------------------------------------------------------------------------

	parameter(Kmax=Nbmx*Nqmx)

c -----------------------------------------------------------------------------
c Dclaration de PhMax, le nombre max de points de discrtisation
c pour la fonction de phase
c -----------------------------------------------------------------------------

	parameter(PhMax=2000)

c -----------------------------------------------------------------------------
c Dclaration de Na, le nombre d'intervalles de discrtisation de
c l'intervalle [0,1] pour acclration du tirage des frquences
c -----------------------------------------------------------------------------

	 parameter(Na=100)


c -----------------------------------------------------------------------------
c Dclaration de kmin, la valeur minimale que le code pourra supporter
c pour les coefficients d'absorption et de diffusion. Si une valeur de ka
c ou kd est trouve infrieure  kmin lors de la lecture des donnes
c spectrales, cette valeur sera remplace par kmin. Le but est d'viter
c les oprations de division par zro.
c -----------------------------------------------------------------------------

	parameter(kmin=1.0D-10)
