      program extract_epsilon
      implicit none
      include '../includes/max.inc'
      include '../includes/param.inc'

      integer band,Nb,i,j,m,band_min,ios,sign,sign_defalut
      double precision epsilon(0:Nmax+1,0:Nmax+1)
      character*100 st
      sign_default=1

      open(10,file='band_min')
      read(10,*) band_min
      close(10)

      open(16,file='./sign')
      read(16,*) sign
      close(16)
      if ((sign.ne.-1).and.(sign.ne.1)) then
         sign=sign_default
      endif

c     Ouverture du fichier
      open(12,file='./epsilon.txt',status='old',iostat=ios)
      if (ios.ne.0) then
         close(12)
         write(*,*) 'File "epsilon.txt" could not be opened"'
      else
         read(12,*) m,Nb
         if (band_min.gt.1) then
            do band=1,band_min-1
               read(12,*)       ! lambda_lo(band),lambda_hi(band)
               do i=0,m+1
                  read(12,*)    ! (epsilon(i,j),j=0,m+1)
               enddo            ! i
            enddo               ! band
         endif
         read(12,*)  ! lambda_lo(band),lambda_hi(band)
         do i=0,m+1
            read(12,'(1p(100e11.3))') (epsilon(i,j),j=0,m+1)
         enddo ! i
         close(12)
      endif

c     Creating .dat and .ctl files:'epsilon.dat', 'epsilon.ctl'
      st='epsilon'
      call write_dat_m(m,epsilon,sign,st)
c     Debug
      open(10,file='eps.txt')
      do i=0,m+1
         write(10,'(1p(100e11.3))') (epsilon(i,j),j=0,m+1)
      enddo
      close(10)

      end
