#!/bin/bash

narg=$#
go=0

while read line
do
  bw=$line
done < "bw"


while read line
do
  path=$line
done < "tmp_dir"

ctl='open '$path
draw='d '
title='draw title '

if [ $narg -eq 2 ] ; then

if [ $2 = 'ner' ] ; then
tmp1='sdpne'
tmp2='- sdpne'
if [ $bw -eq 1 ] ; then
cp rgb_sdpne_bw rgb
cp cl_sdpne_bw cl
else
cp rgb_sdpne rgb
cp cl_sdpne cl
fi
cp linesm lines
cp levm lev
title=$title'Effect of scattering on NER (W/m\`a2\`n)'
go=1
fi

elif [ $narg -eq 3 ] ; then

if [ $2 = 'budget' -a  $3 = 'total' ] ; then
tmp1='sdbilan_tot'
tmp2='sdbilan_tot'
if [ $bw -eq 1 ] ; then
cp rgb_sdbilf_bw rgb
cp cl_sdbf cl
else
cp rgb_sdbilf_bw rgb
cp cl_sdbf cl
fi
cp linesNb lines
cp levNb lev
title=$title'Effect of sca. on tot. budget (mW/m\`a3\`n/cm\`a-1\`n)'
go=1
fi

if [ $2 = 'budget' -a  $3 = 'gas-ground' ] ; then
tmp1='sdbilan_gs'
tmp2='sdbilan_gs'
if [ $bw -eq 1 ] ; then
cp rgb_sbilfgs_bw rgb
cp cl_sdbfgs_bw cl
else
cp rgb_sbilfgs rgb
cp cl_sdbfgs cl
fi
cp linesNb lines
cp levNb lev
title=$title'Effect of sca. on g-gr bud. (mW/m\`a3\`n/cm\`a-1\`n)'
go=1
fi

if [ $2 = 'budget' -a  $3 = 'gas-space' ] ; then
tmp1='sdbilan_ge'
tmp2='sdbilan_ge'
if [ $bw -eq 1 ] ; then
cp rgb_sdbilfge_bw rgb
cp cl_sdbfge_bw cl
else
cp rgb_sdbilfge rgb
cp cl_sdbfge cl
fi
cp linesNb lines
cp levNb lev
title=$title'Effect of sca. on g-sp bud. (mW/m\`a3\`n/cm\`a-1\`n)'
go=1
fi

if [ $2 = 'budget' -a  $3 = 'gas-gas' ] ; then
tmp1='sdbilan_gg'
tmp2='sdbilan_gg'
if [ $bw -eq 1 ] ; then
cp rgb_sdbilfgg_bw rgb
cp cl_sdbfgg _bwcl
else
cp rgb_sdbilfgg rgb
cp cl_sdbfgg cl
fi
cp linesNb lines
cp levNb lev
title=$title'Effect of sca. on g-g bud. (mW/m\`a3\`n/cm\`a-1\`n)'
go=1
fi

if [ $2 = 'heating-rate' -a  $3 = 'total' ] ; then
tmp1='sdbilkj_tot'
tmp2='sdbilkj_tot'
cp rgb_bilf rgb
cp cl_dhr cl
cp linesNb lines
cp levNb lev
title=$title'Effect of sca. on tot. heating-rate (K/s\`n)'
go=1
fi

if [ $2 = 'heating-rate' -a  $3 = 'gas-ground' ] ; then
tmp1='sdbilkj_gs'
tmp2='sdbilkj_gs'
cp rgb_bilf rgb
cp cl_dhr cl
cp linesNb lines
cp levNb lev
title=$title'Effect of sca. on g-gr HR (K/s\`n)'
go=1
fi

if [ $2 = 'heating-rate' -a  $3 = 'gas-space' ] ; then
tmp1='sdbilkj_ge'
tmp2='sdbilkj_ge'
cp rgb_bilf rgb
cp cl_dhr cl
cp linesNb lines
cp levNb lev
title=$title'Effect of sca. on g-sp HR (K/s\`n)'
go=1
fi

if [ $2 = 'heating-rate' -a  $3 = 'gas-gas' ] ; then
tmp1='sdbilkj_gg'
tmp2='sdbilkj_gg'
cp rgb_bilf rgb
cp cl_dhr cl
cp linesNb lines
cp levNb lev
title=$title'Effect of sca. on g-g HR (K/s\`n)'
go=1
fi

fi



ctl=$ctl$tmp1'.ctl'
draw=$draw$tmp2

file=$tmp1
t1='gxeps -c -i out.gx -o '$file'.ps'
t2='gzip -f '$file'.ps'
t3='gv --orientation=LANDSCAPE '$file'.ps.gz'

echo $ctl > ctl
echo $draw > d
echo $title > title
echo $t1 > t1
echo $t2 > t2
echo $t3 > t3
cat d title > dr
cat t0 t1 t2 t3 > t
echo $go > out
