#!/bin/bash

go=0


while read line
do
  path=$line
done < "tmp_dir"

ctl='open '$path
draw='d '
title='draw title '

if [ $2 = 'total' ] ; then
tmp1='bilkj_tot_theo'
cp rgb_bilf rgb
cp cl_hr cl
title=$title'Analytic total heating rate (K/s\`n)'
go=1
elif [ $2 = 'gas-ground' ] ; then
tmp1='bilkj_gs_theo'
cp rgb_bilf rgb
cp cl_hr cl
title=$title'Analytic gas-ground heating rate (K/s\`n)'
go=1
elif [ $2 = 'gas-space' ] ; then
tmp1='bilkj_ge_theo'
cp rgb_bilf rgb
cp cl_hr cl
title=$title'Analytic gas-space heating rate (K/s\`n)'
go=1
elif [ $2 = 'gas-gas' ] ; then
tmp1='bilkj_gg_theo'
cp rgb_bilf rgb
cp cl_hr cl
title=$title'Analytic gas-gas heating rate (K/s\`n)'
go=1
fi


ctl=$ctl$tmp1'.ctl'
draw=$draw$tmp1

file=$tmp1
t1='gxeps -c -i out.gx -o '$file'.ps'
t2='gzip -f '$file'.ps'
t3='gv --orientation=LANDSCAPE '$file'.ps.gz'
cp levNb lev
cp linesNb lines

echo $ctl > ctl
echo $draw > d
echo $title > title
echo $t1 > t1
echo $t2 > t2
echo $t3 > t3
cat d title > dr
cat t0 t1 t2 t3 > t
cp c2 c
echo $go > out
