c     Copyright (C) 2000-2008
c     Universite Paul Sabatier, Toulouse, France

c     This program is free software; you can redistribute it and/or modify
c     it under the terms of the GNU General Public License as published by
c     the Free Software Foundation; either version 2, or (at your option)
c     any later version.

c     This program is distributed in the hope that it will be useful,
c     but WITHOUT ANY WARRANTY; without even the implied warranty of
c     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c     GNU General Public License for more details.

c     You should have received a copy of the GNU General Public License
c     along with this program; if not, write to the Free Software
c     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
c     USA.
c
      subroutine choice_ud(alpha,sens,pdf)

      implicit none

c     Cette routine reoit en entre un angle alpha appartenant  l'intervalle [0,pi/2]
c     et peut renvoyer avec une probabilit 'proba' l'angle pi-alpha
c     --> tirage  'proba' vers le bas, '1-proba' vers le haut
c 

      include 'param.inc'
      include 'max.inc'
      include 'data.inc'
      double precision R,alpha,pdf
      integer sens

c      call rand_uniforme(R)
c      if (R.gt.proba) then
c         alpha=pi-alpha
c      endif

c      if (alpha.lt.pi/2.0D+0) then
c         pdf=1.D+0/proba
c      else
c         pdf=1.0D+0/(1.0D+0-proba)
c      endif

      if (sens.eq.0) then
         alpha=pi-alpha
      endif
      pdf=1.0D+0

      return
      end
