c     Copyright (C) 2000-2008
c     Universite Paul Sabatier, Toulouse, France

c     This program is free software; you can redistribute it and/or modify
c     it under the terms of the GNU General Public License as published by
c     the Free Software Foundation; either version 2, or (at your option)
c     any later version.

c     This program is distributed in the hope that it will be useful,
c     but WITHOUT ANY WARRANTY; without even the implied warranty of
c     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c     GNU General Public License for more details.

c     You should have received a copy of the GNU General Public License
c     along with this program; if not, write to the Free Software
c     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
c     USA.
c
      subroutine coupure()
c
c     Cette routine a pour fonction de dtecter une interruption
c     ventuelle dans le calcul prcdent -- coupure de courant ou
c     reboot sauvage par Stphane ou Richard ou tout autre
c     maitre de conf. qui se croit tout permis du fait qu'il
c     a termin sa thse, qu'ils soient tous maudits et leurs mes
c     voues aux tourments ternels de l'enfer, eux et leur
c     descendance, jusqu' la septime gnration !!!
c     .................................
c     Bref si le calcul prcdent a t sauvagement interrompu
c     il faut bien le reprendre l o il a t arrt...
c     sauf s'il est explicitement prcis de reprendre malgr tout
c     un nouveau calcul dans 'options.in' -- juste au cas o le
c     calcul ait volontairement t arrt par un ctrl-C

      implicit none ! malgr tout
      include 'max.inc'
      include 'data.inc'
      include 'options.inc'
      include 'formats.inc'
      integer i,ios,afp
      character*24 detect,phrase1,phrase2

      phrase1="Reprise du cas prcdent"
      phrase2="Resuming computation in "
      detect="                        "

      open(10,file='options.in',status='old',iostat=ios)
      if (ios.ne.0) then ! file not found
         call screen(1149,0,0,0.0D+0,0.0D+0)
         call screen(15,0,0,0.0D+0,0.0D+0)
         stop
      endif

      do while ((detect.ne.phrase1).and.(detect.ne.phrase2))
         read(10,53) detect
      enddo
      read(10,*) rcp ! rcp=1=> on reprend le calcul s'il a t interrompu

      rewind(10)
      phrase1="Affichage des messages e"
      phrase2="Display error messages ["
      do while ((detect.ne.phrase1).and.(detect.ne.phrase2))
         read(10,53) detect
      enddo
      read(10,*) amsg ! amsg=1=> affichage des messages d'erreur

      close(10)

      open(10,file='./temporary/coupure.dat')
      read(10,*) fin ! fin=1=> calcul prcdent achev ; sinon fin=0

      if ((fin.eq.1).or.(rcp.eq.0)) then
         rewind(10)      ! Si par chance le calcul prcdent a t
         write(10,*) 0   ! achev, on remet quand mme  zro
         raz=0           ! raz=0=> on ne reprend pas le calcul interrompu
         if ((fin.eq.0).and.(rcp.eq.0)) then
            call screen(17,0,0,0.0D+0,0.0D+0)
         else if ((fin.eq.1).and.(rcp.eq.0).and.(ios.eq.0)) then
            call screen(18,0,0,0.0D+0,0.0D+0)
         else if ((fin.eq.1).and.(rcp.eq.1).and.(ios.eq.0)) then
            call screen(18,0,0,0.0D+0,0.0D+0)
         endif
         call screen(19,0,0,0.0D+0,0.0D+0)
      else if ((fin.eq.0).and.(rcp.eq.1)) then ! c'est le seul cas qui reste
c     Dans le cas o fin=0 (calcul non achev) et rcp=1 (reprise du calcul demande)
c     il faut vrifier la prsence des fichiers *.sav ; s'il en manque au moins un,
c     quelqu'un l'a effac, et on n'a pas d'autre choix que de recommencer un calcul.
         afp=1 ! tous fichiers .sav prsents
         open(11,file='./temporary/data.sav',status='old',iostat=ios)
         if (ios.ne.0) then ! file not found
            afp=0
         endif
         close(11)
         open(12,file='./temporary/options.sav',status='old',iostat=ios)
         if (ios.ne.0) then ! file not found
            afp=0
         endif
         close(12)
         open(13,file='./temporary/mesh.sav',status='old',iostat=ios)
         if (ios.ne.0) then ! file not found
            afp=0
         endif
         close(13)
         open(14,file='./temporary/diff.sav',status='old',iostat=ios)
         if (ios.ne.0) then ! file not found
            afp=0
         endif
         close(14)
         open(15,file='./temporary/sauvegarde.txt',
     &        status='old',iostat=ios)
         if (ios.ne.0) then ! file not found
            afp=0
         endif
         close(15)
         open(16,file='./temporary/arrays1.sav',status='old',iostat=ios)
         if (ios.ne.0) then ! file not found
            afp=0
         endif
         close(16)
         open(16,file='./temporary/arrays2.sav',status='old',iostat=ios)
         if (ios.ne.0) then ! file not found
            afp=0
         endif
         close(16)

         if (afp.eq.1) then ! si tous fichiers prsents
            raz=1               ! raz=1=> on reprend le calcul dans l'tat
            call screen(16,0,0,0.0D+0,0.0D+0)
         else ! s'il manque au moins un fichier
            rewind(10)
            write(10,*) 0
            raz=0 ! on commence un nouveau calcul
            call screen(1147,0,0,0.0D+0,0.0D+0)
            call screen(19,0,0,0.0D+0,0.0D+0)
         endif ! afp

      endif ! fin & rcp
      close(10)

 1234 continue
      return
      end
