      subroutine init()
      implicit none
      integer outk,sma
      character*100 dest,fichier,email
c     Purpose: perform various initialisation tasks
      include 'max.inc'
      include 'data.inc'
      include 'email.inc'


c      call write_pid() ! criture du PID de Karine dans le fichier './pid'

      call detect_first_use()

      author_email='eymet@energetique.ups-tlse.fr'
      call read_config(sma)

      call erase_results()
      
      call detect_kernel(outk)
      if (outk.eq.0) then ! default: kernel > 2.4
         call detect_viewer(outv) ! dtection du programme de visualisation graphique
         call detect_javac(javac) ! dtection de javac
c     Debug
c      write(*,*) 'javac=',javac
c      if (javac.eq.1) then
c         write(*,*) 'javac a t dtect'
c      else
c         write(*,*) 'javac n''a pas t dtect'
c      endif
c     Debug
         if (javac.eq.1) then   ! si java est install
c     compilation de l'applet java "overwrite_progress_line.java"
            call system('javac ./bash/overwrite_progress_line.java')
c     compilation de l'applet java "overwrite_init_line.java"
            call system('javac ./bash/overwrite_init_line.java')
c     Debug
c         write(*,*) 'bash/overwrite_line a t compil'
c      else
c         write(*,*) 'bash/overwrite_line n''a pas t compil'
c     Debug
         endif

c     Prparation du texte du mail de lancement de simul
         fichier='mail.txt'
         call make_start_mail(sma,fichier)
c     Debug
c            stop
c     Debug

c     Expdition
         dest=author_email
         call send_mail(sma,dest,fichier)

c     Effacement des fichiers temporaires
         call  erase_temporary()

      else ! if a 2.4 kernel is used
         outv=0
         javac=0
      endif
c     Debug
c      stop
c     Debug

      return
      end
